package edu.ucf.cs.dml.mapthing;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.net.URL;

public class TestAllFrame extends JFrame implements WorldMapCallbackInterface
{
  JPanel contentPane;
  TheWorldPanel wp=null;
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JLabel selectedLabel = new JLabel();
  JButton jButton1 = new JButton();
  URL u=null;
  //Construct the frame
  public TestAllFrame()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    { u=new URL("http://toshi_station.dml.cs.ucf.edu/mmanim/maps/");
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception
  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(xYLayout1);
    this.setSize(new Dimension(729, 525));
    this.setTitle("TestWorld");
    contentPane.setMinimumSize(new Dimension(548, 606));
    contentPane.setPreferredSize(new Dimension(548, 606));
    jLabel1.setText("Selected Area");
    jButton1.setText("Reset");
    jButton1.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jButton1_actionPerformed(e);
      }
    });
    wp=new TheWorldPanel(this,u);
    this.getContentPane().add(wp);
    contentPane.add(jButton1, new XYConstraints(528, 467, -1, -1));
    contentPane.add(jLabel1, new XYConstraints(146, 456, 83, -1));
    contentPane.add(selectedLabel, new XYConstraints(249, 456, -1, -1));
    wp.setVisible(true);

  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }

  public void areaSelected(String area)
  { selectedLabel.setText(area);
    //TODO: Implement this edu.ucf.cs.dml.mapthing.WorldMapCallbackInterface method
  }

  public void finalAreaSelected(String area)
  { selectedLabel.setText(area+ " final");
    //TODO: Implement this edu.ucf.cs.dml.mapthing.WorldMapCallbackInterface method
  }

  void jButton1_actionPerformed(ActionEvent e)
  { wp.resetWorld();

  }
}