
/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package edu.ucf.cs.dml.mapthing;

import java.awt.*;
import javax.swing.JPanel;
import com.borland.jbcl.layout.*;
import java.net.URL;
import java.util.*;

public class TheWorldPanel extends JPanel
{ URL baseURL=null;
  CardLayout cardLayout1 = new CardLayout();
  AfricaPanel africaPanel = null;
  AsiaPanel asiaPanel = null;
  EuropePanel europePanel=null;
  AustraliaPanel australiaPanel=null;
  MiddleEastPanel middleEastPanel=null;
  SouthAmericaPanel southAmericaPanel=null;
  FloridaPanel floridaPanel=null;
  CaribbeanPanel caribbeanPanel=null;
  CentralAmericaPanel centralAmericaPanel=null;
  UnitedStatesPanel unitedStatesPanel=null;
  WorldPanel worldPanel=null;

  WorldMapCallbackInterface callback=null;
  //Hashtable panels=null;
  Vector panels=new Vector();

  public TheWorldPanel(WorldMapCallbackInterface callback,URL baseURL)
  { this.callback=callback;
    this.baseURL=baseURL;
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }



  }

  public TheWorldPanel(WorldMapCallbackInterface callback)
  { this.callback=callback;
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception
  {
    this.setLayout(cardLayout1);
    //asiaPanel=new AsiaPanel();
    if(this.baseURL==null)
    { worldPanel=new WorldPanel();
      africaPanel=new AfricaPanel();
      asiaPanel =new AsiaPanel();
      europePanel = new EuropePanel();
      southAmericaPanel = new SouthAmericaPanel();
      australiaPanel = new AustraliaPanel();
      middleEastPanel = new MiddleEastPanel();
      centralAmericaPanel = new CentralAmericaPanel();
      unitedStatesPanel = new UnitedStatesPanel();
      caribbeanPanel = new CaribbeanPanel();
      floridaPanel = new FloridaPanel();
    }
    else
    { worldPanel=new WorldPanel(baseURL);
      africaPanel=new AfricaPanel(baseURL);
      asiaPanel =new AsiaPanel(baseURL);
      europePanel = new EuropePanel(baseURL);
      southAmericaPanel = new SouthAmericaPanel(baseURL);
      australiaPanel = new AustraliaPanel(baseURL);
      middleEastPanel = new MiddleEastPanel(baseURL);
      centralAmericaPanel = new CentralAmericaPanel(baseURL);
      unitedStatesPanel = new UnitedStatesPanel(baseURL);
      caribbeanPanel = new CaribbeanPanel(baseURL);
      floridaPanel = new FloridaPanel(baseURL);
    }

    worldPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        worldPanel_mapAreaSelected(e);
      }
    });
    africaPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        africaPanel_mapAreaSelected(e);
      }
    });
    asiaPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        asiaPanel_mapAreaSelected(e);
      }
    });
    worldPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        worldPanel_mapAreaSelected(e);
      }
    });
    africaPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        africaPanel_mapAreaSelected(e);
      }
    });
    europePanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        europePanel_mapAreaSelected(e);
      }
    });
    southAmericaPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        southAmericaPanel_mapAreaSelected(e);
      }
    });
    middleEastPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        middleEastPanel_mapAreaSelected(e);
      }
    });
    australiaPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        australiaPanel_mapAreaSelected(e);
      }
    });
    floridaPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        floridaPanel_mapAreaSelected(e);
      }
    });
    unitedStatesPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        unitedStatesPanel_mapAreaSelected(e);
      }
    });
    caribbeanPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        caribbeanPanel_mapAreaSelected(e);
      }
    });
    centralAmericaPanel.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        centralAmericaPanel_mapAreaSelected(e);
      }
    });
    /*this.add(worldPanel,"WorldPanel");
    this.add(africaPanel,"AfricaPanel");
    this.add(asiaPanel,"AsiaPanel" );
    this.add(europePanel,"EuropePanel");
    this.add(southAmericaPanel,"SouthAmericaPanel");
    this.add(middleEastPanel,"MiddleEastPanel");
    this.add(australiaPanel,"AustraliaPanel");
    this.add(floridaPanel,"FloridaPanel");
    this.add(unitedStatesPanel,"UnitedStatesPanel");
    this.add(caribbeanPanel,"CarribeanPanel");
    this.add(centralAmericaPanel,"CentralAmericaPanel");

    panels=new Hashtable();
    panels.put("World","WorldPanel");
    panels.put("Africa","AfricaPanel");// Keep an easily accessable table
    panels.put("Asia","AsiaPanel" );
    panels.put("Europe","EuropePanel");
    panels.put("South America","SouthAmericaPanel");
    panels.put("Middle East","MiddleEastPanel");
    panels.put("Australia","AustraliaPanel");
    panels.put("Florida","FloridaPanel");
    panels.put("United States","UnitedStatesPanel");
    panels.put("Caribbean Islands","CarribeanPanel");
    panels.put("Central America","CentralAmericaPanel");

    this.cardLayout1.addLayoutComponent(worldPanel,"WorldPanel");
    this.cardLayout1.addLayoutComponent(africaPanel,"AfricaPanel");
    this.cardLayout1.addLayoutComponent(asiaPanel,"AsiaPanel");
    this.cardLayout1.addLayoutComponent(europePanel,"EuropePanel");
    this.cardLayout1.addLayoutComponent(australiaPanel,"AustraliaPanel");
    this.cardLayout1.addLayoutComponent(middleEastPanel,"MiddleEastPanel");
    this.cardLayout1.addLayoutComponent(southAmericaPanel,"SouthAmericaPanel");
    this.cardLayout1.addLayoutComponent(unitedStatesPanel,"UnitedStatesPanel");
    this.cardLayout1.addLayoutComponent(centralAmericaPanel,"CentralAmericaPanel");
    this.cardLayout1.addLayoutComponent(caribbeanPanel,"CaribbeanPanel");
    this.cardLayout1.addLayoutComponent(floridaPanel,"FloridaPanel");
    */

    this.addNewMapArea(worldPanel,"World");
    this.addNewMapArea(africaPanel,"Africa");
    this.addNewMapArea(asiaPanel,"Asia");
    this.addNewMapArea(europePanel,"Europe");
    this.addNewMapArea(australiaPanel,"Australia");
    this.addNewMapArea(middleEastPanel,"Middle East");
    this.addNewMapArea(southAmericaPanel,"South America");
    this.addNewMapArea(unitedStatesPanel,"United States");
    this.addNewMapArea(centralAmericaPanel,"Central America");
    this.addNewMapArea(caribbeanPanel,"Caribbean Islands");
    this.addNewMapArea(floridaPanel,"Florida");
    this.cardLayout1.show(this,"World");



  }
  /**
   * PURPOSE: Add a new panel to the whole world
   * @param mapPanel the new panel to add to the whole world
   * @param mapDisplayName the value that displayName has for the GraphicHotspot that
   *  triggers mapPanel to appear
   */
  public void addNewMapArea(MapAreaPanel mapPanel,String mapDisplayName)
  {  this.add(mapPanel,mapDisplayName);
     this.cardLayout1.addLayoutComponent(mapPanel,mapDisplayName);
     this.panels.add(mapDisplayName);
  }

  public Vector getCountryNames()
  { Vector returnVec=new Vector();
    returnVec.addAll(africaPanel.getAreaNames());
    returnVec.addAll(asiaPanel.getAreaNames());
    returnVec.addAll(australiaPanel.getAreaNames());
    returnVec.addAll(caribbeanPanel.getAreaNames());
    returnVec.addAll(europePanel.getAreaNames());
    returnVec.addAll(middleEastPanel.getAreaNames());
    returnVec.addAll(southAmericaPanel.getAreaNames());

    return returnVec;
  }
  public Vector getStatesNames()
  {
    return unitedStatesPanel.getAreaNames();

  }

  public Vector getCountyNames()
  { return this.floridaPanel.getAreaNames();
  }

  protected void mapAreaSelect(String area)
  {

    if(panels.contains(area))
    { this.cardLayout1.show(this,area);
      this.callback.areaSelected(area);
    }
    else
     callback.finalAreaSelected(area);
  }

  void worldPanel_mapAreaSelected(MapAreaSelectedEvent e)
  { mapAreaSelect((String)e.getSource());

  }


  void africaPanel_mapAreaSelected(MapAreaSelectedEvent e)
  {  mapAreaSelect((String)e.getSource());

  }

  void asiaPanel_mapAreaSelected(MapAreaSelectedEvent e)
  { mapAreaSelect((String)e.getSource());

  }

  public void resetWorld()
  { this.cardLayout1.show(this,"World");
  }

  void europePanel_mapAreaSelected(MapAreaSelectedEvent e)
  { mapAreaSelect((String)e.getSource());
  }

  void southAmericaPanel_mapAreaSelected(MapAreaSelectedEvent e)
  { mapAreaSelect((String)e.getSource());
  }

  void middleEastPanel_mapAreaSelected(MapAreaSelectedEvent e)
  { mapAreaSelect((String)e.getSource());
  }

  void australiaPanel_mapAreaSelected(MapAreaSelectedEvent e)
  { mapAreaSelect((String)e.getSource());
  }

  void floridaPanel_mapAreaSelected(MapAreaSelectedEvent e)
  { mapAreaSelect((String)e.getSource());
  }

  void unitedStatesPanel_mapAreaSelected(MapAreaSelectedEvent e)
  { mapAreaSelect((String)e.getSource());
  }

  void caribbeanPanel_mapAreaSelected(MapAreaSelectedEvent e)
  { mapAreaSelect((String)e.getSource());
  }

  void centralAmericaPanel_mapAreaSelected(MapAreaSelectedEvent e)
  { mapAreaSelect((String)e.getSource());
  }


}