
/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package edu.ucf.cs.dml.mapthing;

import java.awt.*;
import javax.swing.JPanel;
import com.borland.jbcl.layout.*;
import com.borland.jbcl.control.*;
import java.io.*;
import java.beans.*;
import java.net.URL;
//the current image attributes are 619,320
public class WorldPanel extends MapAreaPanel implements Serializable
{
  XYLayout xYLayout1 = new XYLayout();
  TransparentImage transparentImage1 = new TransparentImage();
  private String selectedArea="none";
  private transient PropertyChangeSupport propertyChangeListeners = new PropertyChangeSupport(this);
  GraphicHotSpot graphicHotSpot1 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot2 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot3 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot4 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot5 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot7 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot8 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot9 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot10 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot11 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot12 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot13 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot14 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot15 = new GraphicHotSpot();
  GraphicHotSpot graphicHotSpot6 = new GraphicHotSpot();

  public WorldPanel()
  {
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  public WorldPanel(java.net.URL baseURL)
  { this();
    this.baseURL=baseURL;
    try{
     this.transparentImage1.setImageURL(new URL(baseURL,"worldfdp.gif"));
     }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }


  void jbInit() throws Exception
  {
    xYLayout1.setWidth(620);
    xYLayout1.setHeight(400);
    this.setLayout(xYLayout1);
    //transparentImage1.setImageName("C:\\mmanim\\maps\\worldfdp.gif");
    this.setEnabled(true);
    this.setMinimumSize(new Dimension(620, 400));
    this.setPreferredSize(new Dimension(620, 400));
    graphicHotSpot1.setDisplayName("United States");
    graphicHotSpot2.setDisplayName("Canada");
    graphicHotSpot3.setDisplayName("United States");
    graphicHotSpot4.setDisplayName("GreenLand");
    graphicHotSpot5.setDisplayName("Central America");
    graphicHotSpot7.setDisplayName("South America");
    graphicHotSpot8.setDisplayName("Africa");
    graphicHotSpot9.setDisplayName("Africa");
    graphicHotSpot10.setDisplayName("Europe");
    graphicHotSpot11.setDisplayName("Europe");
    graphicHotSpot12.setDisplayName("Middle East");
    graphicHotSpot14.setDisplayName("Asia");
    graphicHotSpot15.setDisplayName("Australia");
    graphicHotSpot13.setDisplayName("Asia");
    graphicHotSpot6.setDisplayName("Caribbean Islands");
    this.add(graphicHotSpot1, new XYConstraints(62, 85, 96, 34));
    this.add(graphicHotSpot2, new XYConstraints(70, 32, 126, 46));
    this.add(graphicHotSpot3, new XYConstraints(30, 32, 36, 26));
    this.add(graphicHotSpot4, new XYConstraints(204, 8, 62, 42));
    this.add(graphicHotSpot5, new XYConstraints(87, 125, 40, 39));
    this.add(graphicHotSpot7, new XYConstraints(137, 159, 75, 145));
    this.add(graphicHotSpot8, new XYConstraints(260, 105, 88, 67));
    this.add(graphicHotSpot9, new XYConstraints(306, 178, 78, 83));
    this.add(graphicHotSpot10, new XYConstraints(271, 56, 33, 46));
    this.add(graphicHotSpot11, new XYConstraints(306, 28, 70, 61));
    this.add(graphicHotSpot12, new XYConstraints(356, 91, 74, 50));
    this.add(graphicHotSpot13, new XYConstraints(392, 22, 162, 74));
    this.add(graphicHotSpot14, new XYConstraints(438, 104, 111, 86));
    this.add(graphicHotSpot15, new XYConstraints(504, 195, 101, 81));
    this.add(graphicHotSpot6, new XYConstraints(128, 128, 32, 14));
    this.add(transparentImage1, new XYConstraints(0, 0, -1, -1));
  }

  void writeObject(ObjectOutputStream oos) throws IOException
  {
    oos.defaultWriteObject();
  }

  void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException
  {
    ois.defaultReadObject();
  }

  public void setSelectedArea(String newSelectedArea)
  {
    String  oldSelectedArea = selectedArea;
    selectedArea = newSelectedArea;
    propertyChangeListeners.firePropertyChange("selectedArea", oldSelectedArea, newSelectedArea);
  }

  public String getSelectedArea()
  {
    return selectedArea;
  }

  public synchronized void removePropertyChangeListener(PropertyChangeListener l)
  {
    super.removePropertyChangeListener(l);
    propertyChangeListeners.removePropertyChangeListener(l);
  }

  public synchronized void addPropertyChangeListener(PropertyChangeListener l)
  {
    super.addPropertyChangeListener(l);
    propertyChangeListeners.addPropertyChangeListener(l);
  }
}