package edu.ucf.cs.dml.simnets.measureme.analysis;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.util.*;
import java.awt.event.*;
import com.borland.jbcl.control.*;
import java.text.*;
/**
 * Title: MeasureMe Analysis Station
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author: Jennifer Farris
 * @version 2.0
 */

public class DiplomaPanel extends JPanel {
  XYLayout xYLayout1=new XYLayout();
  TransparentImage diploma=new TransparentImage();
  JButton backToMen=new JButton();
  ImageIcon menuIcon=null;
  JTextPane jPane=new JTextPane();
  JLabel dateLabel=new JLabel("",JLabel.CENTER);
  JLabel scanLabel=new JLabel();

  public DiplomaPanel()
  {
    this.setBackground(Color.white);
    backToMen.setRequestFocusEnabled(false);
    backToMen.setBorderPainted(false);
    dateLabel.setForeground(Color.black);
    dateLabel.setFont(new java.awt.Font("Times New Roman",1,23));
    scanLabel.setFont(new java.awt.Font("Times New Roman",1,23));
    scanLabel.setForeground(Color.black);
    xYLayout1.setWidth(800);
    xYLayout1.setHeight(600);
    this.setLayout(xYLayout1);

    try
    {
      diploma.setImageName("c:\\analysisart\\diplomabarcode.gif");
      menuIcon=new ImageIcon("c:\\analysisart\\backmenu150x30.gif");
      this.backToMen.setIcon(menuIcon);
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

    this.add(backToMen,new XYConstraints(600,530,150,30));
    this.add(jPane,new XYConstraints(50,270,700,115));
    this.add(dateLabel,new XYConstraints(200,505,390,50));
    this.add(scanLabel,new XYConstraints(670,465,100,30));
    this.add(diploma,new XYConstraints(0,0,-1,-1));
  }

  public void setDateLabel()
  { Calendar calendar = new GregorianCalendar();
    Date date = calendar.getTime();
    DateFormat localFormat = DateFormat.getDateInstance();
    dateLabel.setText( localFormat.format( date ));
  }

  public void setValueLabel(String jText, String scanCode)
  {
    SimpleAttributeSet centerAlign = new SimpleAttributeSet();
    StyleConstants.setAlignment(centerAlign,StyleConstants.ALIGN_CENTER);
    SimpleAttributeSet charStyle1 = new SimpleAttributeSet();
    StyleConstants.setFontFamily(charStyle1, "Times New Roman");
    StyleConstants.setFontSize(charStyle1, 23);
    Document contentModel=jPane.getDocument();
    jPane.setParagraphAttributes(centerAlign,true);
    jPane.setEnabled(false);
    jPane.setBackground(new Color(255,204,51));
    scanLabel.setText(scanCode);
    try{
      contentModel.remove(0,contentModel.getLength());
      contentModel.insertString(contentModel.getLength(),jText, charStyle1);
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }
}