package edu.ucf.cs.dml.simnets.measureme.analysis;
import javax.swing.*;
import java.awt.*;
import java.text.*;
import java.awt.font.*;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class StrikeThru extends JLabel {
  String s=null;
  boolean bStrike=false;

  public StrikeThru(String stng) {
    s=stng;
    setBackground(new Color(255,204,51));
    setOpaque(true);
  }

  public void paintComponent(Graphics g)
  { super.paintComponent(g);
    Graphics2D g2 = (Graphics2D) g;
    if(s!="")
    { g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      Font font = new Font("Sans Serif", Font.BOLD, 12);
      AttributedString as   = new AttributedString(s);
      as.addAttribute(TextAttribute.FONT, font);
      if(bStrike==true)
        as.addAttribute(TextAttribute.STRIKETHROUGH,TextAttribute.STRIKETHROUGH_ON, 0, s.length());
      g2.setColor(new Color(46,0,92));
      g2.setStroke(new BasicStroke(8.0f,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER));
      g2.drawString(as.getIterator(), 20, 30);
    }
  }

  public void drawStrike()
  { bStrike=true;
    repaint();
  }

  public void drawPlain()
  { bStrike=false;
    repaint();
  }

  public void setString(String strng)
  { s=strng;
    repaint();
  }

}
