package edu.ucf.cs.dml.simnets.measureme.analysis;
import java.awt.*;
import com.borland.jbcl.layout.*;
import com.borland.jbcl.control.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.table.TableColumn;
import javax.swing.table.*;
import java.awt.font.*;
import edu.ucf.cs.dml.simnets.measureme.server.*;
import edu.ucf.cs.dml.simnets.measureme.dbase.*;
import edu.ucf.cs.dml.simnets.measureme.client.*;

/**
 * Title: MeasureMe Analysis Station
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author: Jennifer Farris
 * @version 2.0
 */

public class UniquePanel extends JPanel {
  int width=0;
  Color fontColor=new Color(46,0,92);
  String valString;
  TransparentImage stick1=new TransparentImage();
  TransparentImage caption1=new TransparentImage();
  JLabel total=new JLabel("",JLabel.CENTER);
  JLabel people=new JLabel("",JLabel.CENTER);
  JLabel and1=new JLabel("AND",JLabel.CENTER);
  JLabel and2=new JLabel("AND",JLabel.CENTER);
  JToggleButton age=new JToggleButton();
  JToggleButton gender=new JToggleButton();
  StrikeThru ageLab=new StrikeThru("");
  StrikeThru genLab=new StrikeThru("");
  StrikeThru demoLab=new StrikeThru("");
  String queryGrid="";
  String queryTable="";
  JTextArea instr=new JTextArea();
  JToggleButton county=new JToggleButton();
  JButton acceptBtn=new JButton();
  JLabel label1;
  ImageIcon acceptIcon=null;
  TransparentImage titlBar=new TransparentImage();
  ImageIcon lftIcon=null;
  ImageIcon rtIcon=null;
  ImageIcon stickIcon=null;
  ImageIcon ageIcon=null;
  ImageIcon femaleIcon=null;
  ImageIcon maleIcon=null;
  Hashtable countyCodes=null;
  JTextArea instr2=new JTextArea();
  int minAge;
  int maxAge;
  Vector currentStations=new Vector();
  Color backColor=new Color(0,0,128);
  protected String[] stationNames=null;
  Vector lbls=new Vector();
  Vector rowData;
  Vector dataVec=new Vector();
  Vector columnNames=new Vector();
  PopUpInstructions pUp=new PopUpInstructions();
  XYLayout xYLayout1=new XYLayout();
  JButton addBn=new JButton();
  JLabel mDesc=new JLabel("Measurement:",JLabel.CENTER);
  JButton delBn=new JButton();
  TransparentImage stick2=new TransparentImage();
  TransparentImage caption2=new TransparentImage();
  Integer allVals=null;
  Integer genage=null;
  Integer agecounty=null;
  Integer gencounty=null;
  Integer gen=null;
  Integer countyVal=null;
  Integer ageVal=null;
  JTable table;
  TableColumnModel model;
  TableColumn column;
  JLabel msre=new JLabel("",JLabel.CENTER);
  int x=0;
  JButton downBn=new JButton();
  JButton upBn=new JButton();
  JLabel me=new JLabel("ME",JLabel.RIGHT);
  JLabel max=new JLabel("Maximum",JLabel.RIGHT);
  JLabel mean=new JLabel("Mean",JLabel.RIGHT);
  JLabel mode=new JLabel("Mode",JLabel.RIGHT);
  JLabel median=new JLabel("Median",JLabel.RIGHT);
  JLabel min=new JLabel("Minimum",JLabel.RIGHT);
  int labelNum=0;
  ImageIcon addIcon=null;
  ImageIcon delIcon=null;
  ImageIcon dipIcon=null;
  ImageIcon menuIcon=null;
  ImageIcon countyIcon=null;
  StationInfo sInfo=new StationInfo();
  int numCols=-1;
  AnalysisServiceInterface asi=null;
  protected Exhibitor exhibitor=null;
  JButton vwDip=new JButton();
  JButton menuBtn=new JButton();

  public UniquePanel()
  {
  }

  public UniquePanel(AnalysisServiceInterface asi)
  { this.asi=asi;
    this.stationNames=sInfo.getStationNames();

    xYLayout1.setWidth(801);
    xYLayout1.setHeight(601);
    this.setLayout(xYLayout1);

    upBn.addActionListener(new java.awt.event.ActionListener()
    {
          public void actionPerformed(ActionEvent e)
          { upBn_actionPerformed();
          }
    });
    downBn.addActionListener(new java.awt.event.ActionListener()
    {
          public void actionPerformed(ActionEvent e)
          { downBn_actionPerformed();
          }
    });
    age.addActionListener(new java.awt.event.ActionListener()
    {
          public void actionPerformed(ActionEvent e)
          { togg_actionPerformed();
          }
    });
      acceptBtn.addActionListener(new java.awt.event.ActionListener()
    {
          public void actionPerformed(ActionEvent e)
          { accept_actionPerformed();
          }
    });



    gender.addActionListener(new java.awt.event.ActionListener()
    {
          public void actionPerformed(ActionEvent e)
          { togg_actionPerformed();
          }
    });
    county.addActionListener(new java.awt.event.ActionListener()
    {
          public void actionPerformed(ActionEvent e)
          { togg_actionPerformed();
          }
    });
    addBn.addActionListener(new java.awt.event.ActionListener()
    { public void actionPerformed(ActionEvent e){
            addBn_actionPerformed(e);
            }
    });

    delBn.addActionListener(new java.awt.event.ActionListener()
    { public void actionPerformed(ActionEvent e){
            delBn_actionPerformed(e);
            }
    });

    x=65;
    for(int i=0;i<13;i++)
    { label1=new JLabel("",JLabel.CENTER);
      label1.setFont(new java.awt.Font("SansSerif", 1, 14)); // CEH -- changed 9/15/2002
      label1.setForeground(this.fontColor);
      lbls.addElement(label1);
      this.add(((JLabel)lbls.elementAt(i)),new XYConstraints(x,300,55,30));
      x=x+57;
    }

  }

  protected void jbInit()
  { try
    {
      labelNum=0;
      instr.setText("Wonder if you are the only one with your own set of unique qualities? Press the buttons above to deselect or select one or more demographic groups to narrow down the population.  Press confirm to compare your measurements to others in that population.");
      instr.setLineWrap(true);
      instr.disable();
      instr.setDisabledTextColor(this.fontColor);
      instr.setWrapStyleWord(true);
      instr.setFont(new java.awt.Font("SansSerif", 1, 16));
      instr.setForeground(this.fontColor);
      instr2.setLineWrap(true);
      instr2.disable();
      instr2.setDisabledTextColor(this.fontColor);
      instr2.setWrapStyleWord(true);
      instr2.setFont(new java.awt.Font("SansSerif", 1, 14));
      instr2.setForeground(this.fontColor);
      stick1.setImageName("c:\\analysisart\\statstick1.gif");
      caption1.setImageName("c:\\analysisart\\caption440x220.gif");
      stick1.setVisible(true);
      caption1.setVisible(true);
      stick1.setDrawEdge(false);
      caption1.setDrawEdge(false);
      stick2.setVisible(false);
      stick2.setDrawEdge(false);
      stick2.setImageName("c:\\analysisart\\statstick3.gif");
      caption2.setVisible(false);
      caption2.setDrawEdge(false);
      caption2.setImageName("c:\\analysisart\\caption237x220.gif");

      this.vwDip.setVisible(false);
      vwDip.setEnabled(false);
      lftIcon=new ImageIcon("C:\\analysisart\\left18x30orange.gif");
      rtIcon=new ImageIcon("C:\\analysisart\\right18x30orange.gif");
      menuIcon=new ImageIcon("C:\\analysisart\\backmenu150x30.gif");
      dipIcon=new ImageIcon("C:\\analysisart\\viewdiploma.gif");
      addIcon=new ImageIcon("C:\\analysisart\\addorange.gif");
      delIcon=new ImageIcon("C:\\analysisart\\deleteorange.gif");
      stickIcon=new ImageIcon("C:\\analysisart\\stickmanorange.gif");
      ageIcon=new ImageIcon("C:\\analysisart\\age.gif");
      femaleIcon=new ImageIcon("C:\\analysisart\\femaleorange.gif");
      maleIcon=new ImageIcon("C:\\analysisart\\maleorange.gif");
      countyIcon=new ImageIcon("C:\\analysisart\\countyorange.gif");
      acceptIcon=new ImageIcon("C:\\analysisart\\confirmorange.gif");

      upBn.setIcon(rtIcon);
      upBn.setBackground(new Color(255,204,51));
      upBn.setRequestFocusEnabled(false);
      upBn.setBorderPainted(false);
      upBn.setDisabledIcon(rtIcon);

      downBn.setIcon(lftIcon);
      downBn.setBackground(new Color(255,204,51));
      downBn.setRequestFocusEnabled(false);
      downBn.setBorderPainted(false);
      downBn.setDisabledIcon(lftIcon);
      acceptBtn.setEnabled(true);
      acceptBtn.setVisible(true);
      instr.setVisible(true);
      instr2.setVisible(false);
      msre.setVisible(false);
      addBn.setVisible(false);
      delBn.setVisible(false);
      upBn.setVisible(false);
      downBn.setVisible(false);
      me.setVisible(false);
      max.setVisible(false);
      min.setVisible(false);
      mean.setVisible(false);
      mode.setVisible(false);
      median.setVisible(false);
      me.setToolTipText("Your measurement");
      max.setToolTipText("The highest measurement in this population");
      min.setToolTipText("The lowest measurement in this population");
      mean.setToolTipText("The average measurement in this population" );
      mode.setToolTipText("The most frequently occuring measurement in this population");
      median.setToolTipText("The median of this set of measurements is the number in the middle of the ordered list of measurements");
      acceptBtn.setToolTipText("Press Confirm to accept the population");
      addBn.setToolTipText("Press Add to compare this measurement" );
      delBn.setToolTipText("Press Delete to take this measurement out of the comparison");
      vwDip.setToolTipText("Press here to see your MeasureMe diploma!");
      mDesc.setVisible(false);
      age.setEnabled(true);
      gender.setEnabled(true);
      county.setEnabled(true);
      age.setIcon(stickIcon);
      age.setDisabledIcon(stickIcon);
      age.setDisabledSelectedIcon(ageIcon);
      age.setBackground(Color.white);
      age.setRequestFocusEnabled(false);
      age.setBorderPainted(false);
      age.setSelectedIcon(ageIcon);
      age.setToolTipText("Press here to remove age group from the comparison population");
      county.setToolTipText("Press here to remove county of residence from the comparison population");
      gender.setToolTipText("Press here to remove gender from the comparison population");
      countyCodes=asi.getCountyTable();
      county.setIcon(stickIcon);
      county.setBackground(Color.white);
      county.setRequestFocusEnabled(false);
      county.setBorderPainted(false);
      county.setSelectedIcon(countyIcon);
      county.setDisabledIcon(stickIcon);
      county.setDisabledSelectedIcon(countyIcon);
      and1.setVisible(false);
      and2.setVisible(false);
      gender.setIcon(stickIcon);
      gender.setBackground(Color.white);
      gender.setRequestFocusEnabled(false);
      gender.setBorderPainted(false);
      gender.setSelectedIcon(femaleIcon);
      gender.setDisabledIcon(stickIcon);
      gender.setDisabledSelectedIcon(femaleIcon);
      county.setIcon(stickIcon);
      county.setBackground(Color.white);
      county.setRequestFocusEnabled(false);
      county.setBorderPainted(false);

      this.addBn.setIcon(addIcon);
      addBn.setBackground(new Color(255,204,51));
      addBn.setRequestFocusEnabled(false);
      addBn.setBorderPainted(false);
      addBn.setDisabledIcon(addIcon);

      this.delBn.setIcon(delIcon);
      delBn.setBackground(new Color(255,204,51));
      delBn.setRequestFocusEnabled(false);
      delBn.setBorderPainted(false);
      delBn.setDisabledIcon(delIcon);

      this.menuBtn.setIcon(menuIcon);
      menuBtn.setBackground(Color.white);
      menuBtn.setRequestFocusEnabled(false);
      menuBtn.setBorderPainted(false);
      menuBtn.setDisabledIcon(menuIcon);

      this.vwDip.setIcon(dipIcon);
      vwDip.setBackground(Color.white);
      vwDip.setRequestFocusEnabled(false);
      vwDip.setBorderPainted(false);
      vwDip.setDisabledIcon(dipIcon);

      acceptBtn.setDisabledIcon(acceptIcon);
      acceptBtn.setEnabled(true);
      downBn.setEnabled(false);
      ageLab.setFont(new java.awt.Font("SansSerif", 1, 16)); // CEH -- changed 9/15/2002
      if(exhibitor.getAge()!=-1)
      {
        if(exhibitor.getAge()%10 != 0)
        {
          minAge=((int)(exhibitor.getAge()/10)*10)+1;
          maxAge=(int)((exhibitor.getAge()/10) +1)*10;
        }
        else
        { minAge=exhibitor.getAge()-9;
          maxAge=exhibitor.getAge();
        }
        age.setSelected(true);
        ageLab.setString(new Integer(minAge).toString() + "-" + new Integer(maxAge).toString() + " years old");
        ageLab.drawPlain();
        age.setVisible(true);
      }
      else
      { age.setEnabled(false);
        ageLab.setString("");
        age.setSelected(false);
        age.setVisible(false);
      }
      this.add(ageLab,new XYConstraints(580,120,150,40));

      genLab.setFont(new java.awt.Font("SansSerif", 1, 16)); // CEH -- changed 9/15/2002
      if(exhibitor.getGender()=='F')
      {  genLab.setString("Female");
         gender.setSelected(true);
         genLab.drawPlain();
         gender.setVisible(true);
      }
      else if(exhibitor.getGender()=='M')
      {    genLab.setString("Male");
            gender.setSelected(true); // CEH changed on 9/13/2002
            genLab.drawPlain();
            gender.setVisible(true);
      }
      else
      {  gender.setEnabled(false);
         genLab.setString("");
         gender.setVisible(false);
         gender.setSelected(false);
      }

      demoLab.setFont(new java.awt.Font("SansSerif", 1, 16)); // CEH -- changed 9/15/2002
      if(exhibitor.getCountyCode()!=-1)
      { demoLab.setString("Living in " + countyCodes.get(new Integer((int)exhibitor.getCountyCode())) + " County");
        county.setSelected(true);
        demoLab.drawPlain();
        county.setVisible(true);
      }
      else
      { county.setEnabled(false);
        county.setVisible(false);
        demoLab.setString("");
        county.setSelected(false);
      }

      acceptBtn.setIcon(acceptIcon);
      acceptBtn.setBorderPainted(false);
      acceptBtn.setRequestFocusEnabled(false);
      mDesc.setForeground(this.fontColor);
      msre.setForeground(this.fontColor);
      msre.setBorder(BorderFactory.createLineBorder(Color.black));
      titlBar.setImageName("c:\\analysisart\\uniqueOSClogofinal.gif");

      this.add(msre,new XYConstraints(168,270,100,30));
      this.add(downBn,new XYConstraints(150,270,18,30));
      this.add(upBn,new XYConstraints(268,270,18,30));
      this.add(mDesc,new XYConstraints(150,240,136,30));

      this.setBackground(Color.white);
      and1.setForeground(this.fontColor);
      and2.setForeground(this.fontColor);
      total.setForeground(this.fontColor);
      people.setForeground(this.fontColor);
      total.setFont(new Font("Sans Serif",1,20));
      people.setFont(new Font("Sans Serif",1,20));
      instr.setBackground(new Color(255,153,0));
      instr2.setBackground(new Color(255,153,0));

      this.add(addBn,new XYConstraints( 311,270,75,30));
      this.add(delBn,new XYConstraints( 50,270,75,30));
      this.add(age,new XYConstraints(550,130,30,30));
      this.add(and1,new XYConstraints(550,160,30,20));
      this.add(gender,new XYConstraints(550,180,30,30));
      this.add(and2,new XYConstraints(550,210,30,20));
      this.add(county,new XYConstraints(550,230,30,30));
      this.add(acceptBtn,new XYConstraints(550,270,60,30));
      this.add(instr,new XYConstraints(365,330,340,150));

      this.add(stick1,new XYConstraints(20,320,-1,-1));
      this.add(caption1,new XYConstraints(320,300,-1,-1));

      this.add(instr2,new XYConstraints(425,330,190,155));
      this.add(caption2,new XYConstraints(400,300,-1,-1));
       this.add(stick2,new XYConstraints(563,320,-1,-1));
      this.add(genLab,new XYConstraints(580,170,150,40));
      this.add(demoLab,new XYConstraints(580,220,200,40));
      this.add(total,new XYConstraints(110,103,75,30));
      this.add(people,new XYConstraints(305,157,67,30));
      this.add(me,new XYConstraints(0,330,60,30));
      this.add(max,new XYConstraints(0,360,60,30));
      this.add(mean,new XYConstraints(0,390,60,30));
      this.add(mode,new XYConstraints(0,420,60,30));
      this.add(median,new XYConstraints(0,450,60,30));
      this.add(min,new XYConstraints(0,480,60,30));
      this.add(vwDip,new XYConstraints(530,530,150,30));
      this.add(menuBtn,new XYConstraints(370,530,150,30));
      this.add(titlBar,new XYConstraints(0,0,-1,-1));

      me.setForeground(this.fontColor);
      mean.setForeground(this.fontColor);
      mode.setForeground(this.fontColor);
      median.setForeground(this.fontColor);
      min.setForeground(this.fontColor);
      max.setForeground(this.fontColor);

      if(age.isSelected() && gender.isSelected())
        and1.setVisible(true);
      else
        and1.setVisible(false);
      if(age.isSelected() && county.isSelected())
        and2.setVisible(true);
     else
      { if(gender.isSelected() && county.isSelected())
          and2.setVisible(true);
        else
          and2.setVisible(false);
    }

    downBn.setEnabled(false);
    upBn.setEnabled(true);
  }
  catch(Exception e)
  { e.printStackTrace();
  }

}

    void addBn_actionPerformed(ActionEvent e)
    {
        boolean bThere=false;
        int labNum=0;
        for(int i=0;i<currentStations.size()+1;i++)
        {
//          if(((JLabel)lbls.elementAt(i)).getText().compareTo(msre.getText())==0) {
          System.out.println("Comparing "+msre.getText()+" to "+ ((JLabel)lbls.elementAt(i)).getText());
          if((msre.getText()+" ").startsWith(((JLabel)lbls.elementAt(i)).getText()+" "))
            bThere=true;
        }
        boolean upEnabled=false;
        boolean downEnabled=false;
        if(upBn.isEnabled())
          upEnabled=true;
        if(downBn.isEnabled())
          downEnabled=true;

         upBn.setEnabled(false);
        downBn.setEnabled(false);
        addBn.setEnabled(false);
        delBn.setEnabled(false);
        menuBtn.setEnabled(false);
        vwDip.setEnabled(false);
    if(bThere==false)
    {

        numCols++;

        if(numCols!=0)
          width=width+57;

        else
        {  width=width+114;
            numCols=1;
        }

        this.add(table,new XYConstraints(65,330,width,180));
        this.add(titlBar,new XYConstraints(0,0,-1,-1));


        //remove # to add on later
        if(numCols!=1)
        { column=model.getColumn(numCols-1);
          table.removeColumn(column);

        }


        for(int i=0;i<currentStations.size()+1;i++)
        {

//          if((((String)columnNames.elementAt(i)).compareTo(msre.getText()))==0)
          if((msre.getText()+" ").startsWith(((String)columnNames.elementAt(i))+" "))
            labNum=i;
        }


      System.out.println("Label number = "+labNum);
      table.addColumn(new TableColumn(labNum));

      table.addColumn(new TableColumn(columnNames.size()-1));
      if(numCols<6)
      {  caption2.setVisible(true);
         stick2.setVisible(true);
         instr2.setVisible(true);
      }
      else
      { caption2.setVisible(false);
        stick2.setVisible(false);
        instr2.setVisible(false);
      }

       for(int i=0;i<=numCols;i++)
      {  /* CEH -- 9/15/2002
          ((JLabel)lbls.elementAt(i)).setText(table.getColumnName(i));
          System.out.println(table.getColumnName(i));

          if(table.getColumnName(i).compareTo("Finger Length")==0 || table.getColumnName(i).compareTo("Reaction Time")==0 || table.getColumnName(i).compareTo("Foot Length")==0)
            ((JLabel)lbls.elementAt(i)).setFont(new java.awt.Font("SansSerif", 1, 8));
          else
             ((JLabel)lbls.elementAt(i)).setFont(new java.awt.Font("SansSerif", 1, 9));
          */
          String columnName = table.getColumnName(i)+" ";
          ((JLabel)lbls.elementAt(i)).setText(columnName.substring(0,columnName.indexOf(" ")));
          ((JLabel)lbls.elementAt(i)).setFont(new java.awt.Font("SansSerif", 1, 14));  // CEH -- changed 9/15/2002
      }

        QueryResults qr;
        String vName=ripSpaces(msre.getText());


        try{

        Class valueMapClass = Class.forName("edu.ucf.cs.dml.simnets.measureme.client." + vName + "ValueMap");
        ValueMap vm = (ValueMap) valueMapClass.newInstance();




        //me column
        //if(vName.compareTo("Grip")!=0)
        ((Vector)dataVec.elementAt(0)).setElementAt("  " + new Integer(((Number)vm.getActualValue(new Short(this.exhibitor.getScoreInfo((short) (sInfo.getID(msre.getText())+1)).getScore()))).intValue()) + " " + vm.getMetricUnits(),labNum);

         //((Vector)dataVec.elementAt(0)).setElementAt("  " + new Integer((int)((Short)vm.getActualValue(new Short(this.exhibitor.getScoreInfo((short) (sInfo.getID(msre.getText())+1)).getScore()))).shortValue()) + " " + vm.getMetricUnits(),labNum);




        qr=this.asi.performQuery(new QueryReplyRequest("select * from " + queryTable + " where exhibitnames.exhibitname='" + msre.getText() + "' and exhibitnames.exhibitcode=" + queryTable + ".exhibitcode " + queryGrid,
        "Sheeat",true));
        ResultHolder rh=qr.getResults();
        int columnCt =rh.getColumnCount();



        //column 1=age, column2=exhibitcode,column3=scores
        Vector v=rh.getColumn(columnCt);
        System.out.println("rows " + rh.getRowCount());
        System.out.println("columns " + rh.getColumnCount());
        //create a Short[] with number of scores for the entire age range
        Short[] allScores;
        int i;
        int p;

        if(queryTable == "exhibitagescores" || queryTable=="exhibitagegenderscores" || queryTable=="exhibitagegendercountyscores" || queryTable=="exhibitagecountyscores")
        {allScores=new Short[256];
        for(int t=0;t<256;t++)
          allScores[t]=new Short((short)0);




        for(i=minAge;i<=maxAge;i++)
        { Short[] s=(Short[])v.get(i-1);
          for(p=0;p<256;p++)
          { allScores[p]=new Short((short)(allScores[p].shortValue() + s[p].shortValue()));
          }
        }

        }
        else
         allScores=(Short[])v.get(0);

          float avg=0f;    //sumScores/numScores
        int numScores=0; //number of people with scores
        int sumScores=0; //sum of all scores in age group


           for(p=0;p<256;p++)
          { numScores += (int)allScores[p].shortValue();
            sumScores += ((int)allScores[p].shortValue() * p);
          }

        if(numScores==0)
        {   ((Vector)dataVec.elementAt(1)).setElementAt("-",labNum);
            ((Vector)dataVec.elementAt(2)).setElementAt("-",labNum);
            ((Vector)dataVec.elementAt(3)).setElementAt("-",labNum);
            ((Vector)dataVec.elementAt(4)).setElementAt("-",labNum);
            ((Vector)dataVec.elementAt(5)).setElementAt("-",labNum);
        }
        else
        {

        int maxScore=0;


        for(p=allScores.length-1;p>=0;p--)
        { if(allScores[p].shortValue()!= (short)0)
          { maxScore=p;
            break;
          }
        }




        ((Vector)dataVec.elementAt(1)).setElementAt("  " + new Integer(((Number)vm.getActualValue(new Short((short)maxScore))).intValue()) + " " + vm.getMetricUnits(),labNum);




        System.out.println("Number of scores is: " + numScores);
        if(numScores!=0)
          avg=(float)(sumScores/numScores);
        else
          avg=0f;
        System.out.println("sum of scores is" + sumScores);
        System.out.println("average is " + avg);
        System.out.println("converted average is " + (short)avg);

        ((Vector)dataVec.elementAt(2)).setElementAt("  " + new Integer(((Number)vm.getActualValue(new Short((short)avg))).intValue()) + " " + vm.getMetricUnits(),labNum);

        //mode
        short maxFreq=(short)0;
        short topValue=(short)0;
        for(i=0;i<256;i++)
        { if(allScores[i].shortValue() > maxFreq)
          { maxFreq=allScores[i].shortValue();
            topValue=(short)i;
          }
        }

        ((Vector)dataVec.elementAt(3)).setElementAt("  " + new Integer(((Number)vm.getActualValue(new Short(topValue))).intValue()) + " " + vm.getMetricUnits(),labNum);

        int midIndex=0;
        short sumThru=(short)0;
        int medianScore=0;
        if(numScores!=0)
        { if((numScores % 2)!=0)
          { midIndex=((numScores-1)/2)+1;
          for(p=0;p<256;p++)
          { sumThru+=allScores[p].shortValue();
            if(sumThru>=midIndex)
            { medianScore=p;
              break;
            }
          }
        }
        else
        { int tempScore=0;
          midIndex=numScores/2;
          for(p=0;p<256;p++)
          { sumThru+=allScores[p].shortValue();
            if(sumThru>=midIndex)
            { if(sumThru==midIndex)
              { tempScore=p;
                //search for the next score in list
                for(i=p+1;i<256;i++)
                { if(allScores[i].shortValue()!=0)
                  { tempScore+=i;
                    break;
                  }
                }
                medianScore=(int)(tempScore/2);

              }
              else  //next score in list is same as previous score
                medianScore=p;

              break;
            }
          }
        }
        }
        else
        { medianScore=0;
        }
       ((Vector)dataVec.elementAt(4)).setElementAt("  " + new Integer(((Number)vm.getActualValue(new Short((short)medianScore))).intValue()) + " " + vm.getMetricUnits(),labNum);


        int minScore=0;


        for(p=0;p<256;p++)
        { if(allScores[p].shortValue()!= (short)0)
          { minScore=p;
            break;
          }
        }


        ((Vector)dataVec.elementAt(5)).setElementAt("  " + new Integer(((Number)vm.getActualValue(new Short((short)minScore))).intValue()) + " " + vm.getMetricUnits(),labNum);

         }

      }


        catch(Exception ex)
        {
          ex.printStackTrace();
        }






      }

      String qString=this.getQuery();
      System.out.println(qString);


      QueryResults qr= this.asi.performQuery(new QueryReplyRequest(qString,"Sheeat",true));
      Integer num=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());
      System.out.println("Number of people returned from db:"+ num);
     ((Vector)dataVec.elementAt(0)).setElementAt("  " + num,columnNames.size()-1);

    if(num.intValue()==0)
      setUpDiploma();

    else
    {  this.vwDip.setVisible(false);
        vwDip.setEnabled(false);
        instr2.setText("The # column in the table shows how many people have the same combination of selected measurements as you. Add more measurements to find a combination that makes you unique."  );
    }

      if(upEnabled==true)
        upBn.setEnabled(true);
      if(downEnabled==true)
        downBn.setEnabled(true);
        addBn.setEnabled(true);
        delBn.setEnabled(true);
        menuBtn.setEnabled(true);
        vwDip.setEnabled(true);



    }
    void delBn_actionPerformed(ActionEvent e)
    {

        boolean bThere=false;
        int labNum=0;
        for(int i=0;i<currentStations.size()+1;i++)
        {
//          if((((JLabel)lbls.elementAt(i)).getText()).compareTo(msre.getText())==0)
          System.out.println("Comparing "+msre.getText()+" to "+ ((JLabel)lbls.elementAt(i)).getText());
          if((msre.getText()+" ").startsWith(((JLabel)lbls.elementAt(i)).getText()+" "))
            bThere=true;
        }
    if(bThere==true)
    {   //instr2.setText(instr2.getText() + "\n" + "Please wait while I calculate these statistics......."); // CEH
        numCols--;
        if(numCols!=0)
          width=width-57;
        else
          width=0;


          this.add(table,new XYConstraints(65,330,width,180));
          this.add(titlBar,new XYConstraints(0,0,-1,-1));

        for(int i=0;i<currentStations.size()+1;i++)
        {

//          if(((JLabel)lbls.elementAt(i)).getText().compareTo(msre.getText())==0)
          if((msre.getText()+" ").startsWith(((JLabel)lbls.elementAt(i)).getText()+" "))
            labNum=i;
        }

        column=model.getColumn(labNum);
        table.removeColumn(column);
        if(numCols==0)
        { column=model.getColumn(0);
          table.removeColumn(column);
          numCols=-1;

          for(int i=0;i<currentStations.size()+1;i++)
            ((JLabel)lbls.elementAt(i)).setText("");
        }
        else

      {
       if(numCols<6)
      {  caption2.setVisible(true);
         stick2.setVisible(true);
         instr2.setVisible(true);
      }
      else
      { caption2.setVisible(false);
        stick2.setVisible(false);
        instr2.setVisible(false);
      }


      for(int i=0;i<=numCols;i++)
      {  /* CEH -- 9/15/2002
          ((JLabel)lbls.elementAt(i)).setText(table.getColumnName(i));
          System.out.println(table.getColumnName(i));

          if(table.getColumnName(i).compareTo("Finger Length")==0 || table.getColumnName(i).compareTo("Reaction Time")==0 || table.getColumnName(i).compareTo("Foot Length")==0)
            ((JLabel)lbls.elementAt(i)).setFont(new java.awt.Font("SansSerif", 1, 8));
          else
             ((JLabel)lbls.elementAt(i)).setFont(new java.awt.Font("SansSerif", 1, 9));
          */
          String columnName = table.getColumnName(i)+" ";
          ((JLabel)lbls.elementAt(i)).setText(columnName.substring(0,columnName.indexOf(" ")));
          ((JLabel)lbls.elementAt(i)).setFont(new java.awt.Font("SansSerif", 1, 14));  // CEH -- changed 9/15/2002
          System.out.println("Added column labelled "+columnName);
      }
      for(int i=numCols+1;i<currentStations.size()+1;i++)
         ((JLabel)lbls.elementAt(i)).setText("");


        }

     String qString=this.getQuery();
      System.out.println(qString);


      QueryResults qr= this.asi.performQuery(new QueryReplyRequest(qString,"Sheeat",true));
      Integer num=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());
      System.out.println("Number of people returned from db:"+ num);
     ((Vector)dataVec.elementAt(0)).setElementAt("  " + num,columnNames.size()-1);
     if(num.intValue()==0)
      setUpDiploma();

     else
      {   this.vwDip.setVisible(false);
          vwDip.setEnabled(false);
          //instr2.setText(instr2.getText() + "\n" + "Please wait while I calculate these statistics......."); // CEH
         if(numCols<=0)
          instr2.setText("Use the left and right arrows to select measurements you want to compare.  Press the Add button to add this measurement to the list.  Press the Delete button to remove the measurement from the list.");
         else
          instr2.setText("The # column in the table shows how many people have the same combination of selected measurements as you. Add more measurements to find a combination that makes you unique."  );
      }

    }


  }
    void upBn_actionPerformed()
    { labelNum++;
      msre.setText(((String)currentStations.elementAt(labelNum)));
      if(labelNum==currentStations.size()-1)
        upBn.setEnabled(false);
      downBn.setEnabled(true);

    }
    void downBn_actionPerformed()
    { labelNum--;
      msre.setText(((String)currentStations.elementAt(labelNum)));
      if(labelNum==0)
        downBn.setEnabled(false);
      upBn.setEnabled(true);

    }

  public void setClientExhibitor(Exhibitor exhibitor)
  {  this.exhibitor=exhibitor;

     jbInit();
     numCols=-1;
      width=0;
      dataVec.removeAllElements();
     columnNames.removeAllElements();
     currentStations.removeAllElements();
     this.setUpLabels();
     if(currentStations.size()==1)
     {   upBn.setEnabled(false);
         downBn.setEnabled(false);

     }
  }





  protected void setUpLabels()
  {

    try{
      for(int i=0; i<stationNames.length;i++)
      {

       if((this.stationAvailable(this.stationNames[i])) && (exhibitor.getScoreInfo((short)(i+1))!=null))
       {
          System.out.println(this.stationNames[i]);
          columnNames.addElement(this.stationNames[i]);
          currentStations.addElement(this.stationNames[i]);

      }





      }
        columnNames.addElement("#");

         for(int i=0;i<6;i++)
        { rowData=new Vector();
          for(int n=0;n<columnNames.size();n++)
            rowData.addElement("");
          dataVec.addElement(rowData);
        }
        table = new JTable(dataVec, columnNames);
        TableCellRenderer renderer = new UniqueCellRenderer();
        try {
          table.setDefaultRenderer( Class.forName( "java.lang.Object" ), renderer );
        }
        catch( ClassNotFoundException ex ){
        }

        table.setColumnSelectionAllowed(false);
        table.setRowSelectionAllowed(false);
        table.setEnabled(false);
        table.setShowGrid(true);
        table.setGridColor(Color.black);

         model=table.getColumnModel();
        for(int i=0;i<columnNames.size();i++)
        { column=model.getColumn(0);
          table.removeColumn(column);
        }
        msre.setText(((String)currentStations.elementAt(0)));

        this.add(table,new XYConstraints(65,330,width,180));
        this.add(titlBar,new XYConstraints(0,0,-1,-1));

        table.setBorder(BorderFactory.createLineBorder(Color.black));
        table.setRowHeight(30);
     }
     catch(Exception e)
     { e.printStackTrace();
     }




  }


  protected boolean stationAvailable(String stationName)
  { int i=0;
    ExhibitAvailableInfo inf=null;
    while(i<stationNames.length)
    { inf=new ExhibitAvailableInfo((short)(sInfo.getID(stationNames[i])),stationNames[i]);
      if(inf.getStationName().equals(stationName))
       return inf.isAvalable();
      i++;
    }
    return false;
  }


  protected String ripSpaces(String stringToRip)
  { String localStr=new String(stringToRip);
    if(localStr.indexOf(" ")>-1)
    {
      return ripSpaces(localStr.substring(0,localStr.indexOf(" "))+localStr.substring(localStr.indexOf(" ")+1)) ;
    }
    else
     return localStr;
  }


  protected String getQuery()
  { String qString="select count(id) from exhibitor"; //the basis query
    boolean andMode=false;
    if(this.gender.isSelected())
    { qString+= " where ";
      qString+= this.getGenderQuery();
      andMode=true;

    }
    if(this.age.isSelected())
    { if(!andMode)
       qString+= " where";
      else
        qString+=" and";
      qString+= this.getAgeQuery();
      andMode=true;
    }

    if(this.county.isSelected())
    { if(!andMode)
       qString+= " where";
      else
        qString+=" and";

      qString+= " countyCode = " + this.exhibitor.getCountyCode();
      andMode=true;
    }



      for(int i=0;i<=numCols-1;i++)
      {   if(andMode)
          { qString+= " and ";
          }
          else
          { qString+= " where ";
            andMode=true;
          }
          System.out.println(this.sInfo.getID(table.getColumnName(i)));
          qString+=this.getQueryForStationScore(this.sInfo.getID(table.getColumnName(i)));





        }









    return qString+";";
  }


  protected String getAgeQuery()
  { return " age >= "+ minAge + " and age <= " + maxAge;


  }



  protected String getGenderQuery()
  { char[] gStr=new char[1];
    gStr[0]=this.exhibitor.getGender();

    return " gender='"+new String(gStr)+"'";
  }
  /**
   * Get the query for an individual station based on its id
   */

  protected String getQueryForStationScore(int stationId)
  { return "exhibitor.stationValues["+ Integer.toString((stationId)*4 +1)+"] = "
            + Integer.toString(this.exhibitor.getScoreInfo((short) (stationId+1)).getScore());
  }





  void togg_actionPerformed()
  {
    if(gender.isSelected())
    {
        genLab.drawPlain();
        gender.setToolTipText("Press here to remove gender from the comparison population");

    }
    else
    {
        genLab.drawStrike();
        gender.setToolTipText("Press here to compare your measurements to others of your gender");
     }
   if(age.isSelected())
   {
        ageLab.drawPlain();
        age.setToolTipText("Press here to remove age group from the comparison population");
    }
    else
    {
      ageLab.drawStrike();
      age.setToolTipText("Press here to compare your measurements to others in your age group");
    }
    if(county.isSelected())
     {
        demoLab.drawPlain();
        county.setToolTipText("Press here to remove county of residence from the comparison population");
    }
    else
    {
      demoLab.drawStrike();
      county.setToolTipText("Press here to compare your measurements to others living in your county");
    }

     if(age.isSelected() && gender.isSelected())
          and1.setVisible(true);

      else
          and1.setVisible(false);
    if(age.isSelected() && county.isSelected())
          and2.setVisible(true);
     else
    {   if(gender.isSelected() && county.isSelected())
          and2.setVisible(true);
        else
          and2.setVisible(false);
    }


    if(gender.isSelected() && age.isSelected() && county.isSelected())
    {

        if(allVals.intValue()== -1)
        { QueryResults qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where " + getAgeQuery() + " and " + getGenderQuery() + " and countyCode= " + exhibitor.getCountyCode(),"Sheeat",true));
          allVals=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());
        }
        people.setText(allVals.toString());
         queryTable="exhibitagegendercountyscores";
        queryGrid=" and exhibitagegendercountyscores.gender= '" + exhibitor.getGender()+ "' and exhibitagegendercountyscores.countyCode=" + exhibitor.getCountyCode() + " order by age";

    }


    else if(gender.isSelected() && age.isSelected() && !county.isSelected())
    {

        if(genage.intValue() == -1)
        {
          QueryResults qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where " + getAgeQuery() + " and " + getGenderQuery(),"Sheeat",true));
          genage=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());
        }
        people.setText(genage.toString());
         queryTable="exhibitagegenderscores";
        queryGrid=" and exhibitagegenderscores.gender= '" + exhibitor.getGender()+ "' order by age";
    }
     else if(!gender.isSelected() && age.isSelected() && county.isSelected())
    {   if(agecounty.intValue() == -1)
        {
       QueryResults qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where " + getAgeQuery() +  " and countyCode= " + exhibitor.getCountyCode(),"Sheeat",true));
       agecounty=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());
        }
        people.setText(agecounty.toString());
         queryTable="exhibitagecountyscores";
        queryGrid=" and exhibitagecountyscores.countyCode= " + exhibitor.getCountyCode() + " order by age";
    }
    else if(gender.isSelected() && !age.isSelected() && county.isSelected())
    {
        if(gencounty.intValue() == -1)
        { QueryResults qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where countyCode= " + exhibitor.getCountyCode() + " and " + getGenderQuery(),"Sheeat",true));
          gencounty=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());
        }
        people.setText(gencounty.toString());
         queryTable="exhibitgendercountyscores";
        queryGrid=" and exhibitgendercountyscores.gender = '" + exhibitor.getGender() + "' and exhibitgendercountyscores.countyCode= " + exhibitor.getCountyCode();
    }
     else if(gender.isSelected() && !age.isSelected() && !county.isSelected())
    {
        if(gen.intValue() == -1)
        { QueryResults qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where " + getGenderQuery(),"Sheeat",true));
          gen=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());
        }
        people.setText(gen.toString());
        queryTable="exhibitgenderscores";
        queryGrid=" and exhibitgenderscores.gender = '" + exhibitor.getGender() + "'";
    }
     else if(!gender.isSelected() && !age.isSelected() && county.isSelected())
    {
        if(countyVal.intValue() == -1)
        { QueryResults qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where countyCode= " + exhibitor.getCountyCode(),"Sheeat",true));
          countyVal=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());
        }
        people.setText(countyVal.toString());
        queryTable="exhibitcountyscores";
        queryGrid=" and exhibitcountyscores.countyCode = " + exhibitor.getCountyCode();
    }
    else if(!gender.isSelected() && age.isSelected() && !county.isSelected())
    {
        if(ageVal.intValue() == -1)
        { QueryResults qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where " + getAgeQuery(), "Sheeat",true));
          ageVal=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());
        }
        people.setText(ageVal.toString());
        queryGrid="order by age;";
        queryTable="exhibitagescores";
    }
    else
    {  people.setText(total.getText());
         queryGrid="";
        queryTable="exhibitallscores";
    }
    // if (!acceptBtn.isEnabled()) accept_actionPerformed(); // CEH -- 9/15/2002
 }


  void resetAll()
  {  numCols=-1;
    width=0;

    table.setVisible(false);
    for(int i=0;i<currentStations.size()+1;i++)
      ((JLabel)lbls.elementAt(i)).setText("");
    dataVec.removeAllElements();
    columnNames.removeAllElements();
    currentStations.removeAllElements();
    this.setUpLabels();



    jbInit();
  }
  void accept_actionPerformed()
  {
    instr.setVisible(false);
    instr2.setVisible(true);
    instr2.setText("Use the left and right arrows to select measurements you want to compare.  Press the Add button to add this measurement to the list.  Press the Delete button to remove the measurement from the list.");
    table.setVisible(true);
    msre.setVisible(true);
    addBn.setVisible(true);
    delBn.setVisible(true);
    upBn.setVisible(true);
    downBn.setVisible(true);
    me.setVisible(true);
    max.setVisible(true);
    min.setVisible(true);
    mean.setVisible(true);
    mode.setVisible(true);
    median.setVisible(true);
    acceptBtn.setEnabled(false); // CEH -- changed 9/15/2002
    acceptBtn.setVisible(false); // CEH -- changed 9/13/2002
    age.setEnabled(false); // CEH -- changed 9/15/2002
    gender.setEnabled(false); // CEH -- changed 9/15/2002
    county.setEnabled(false); // CEH -- changed 9/15/2002
    age.setToolTipText(""); // CEH -- changed 9/15/2002
    gender.setToolTipText(""); // CEH -- changed 9/15/2002
    county.setToolTipText(""); // CEH -- changed 9/15/2002
    mDesc.setVisible(true);
    stick1.setVisible(false);
    caption1.setVisible(false);
    stick2.setVisible(true);
    caption2.setVisible(true);



  }
  void intlNumPeople()
  {   allVals=new Integer(-1);
      genage=new Integer(-1);
      agecounty=new Integer(-1);
      gencounty=new Integer(-1);
      gen=new Integer(-1);
      countyVal=new Integer(-1);
      ageVal=new Integer(-1);

     QueryResults qr=null;
     qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor","Sheeat",true));
     Integer tNum=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());

     this.total.setText(tNum.toString());
     if(exhibitor.getAge()!=-1)
     {  if(exhibitor.getAge()%10 != 0)
        {
          minAge=((int)(exhibitor.getAge()/10)*10)+1;
          maxAge=(int)((exhibitor.getAge()/10) +1)*10;
        }
        else
        { minAge=exhibitor.getAge()-9;
          maxAge=exhibitor.getAge();
        }
     }


     if((exhibitor.getGender()!='N') && (exhibitor.getAge()!=-1) && (exhibitor.getCountyCode()!=-1))
    {


        qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where " + getAgeQuery() +  " and " + getGenderQuery() + " and countyCode= " + exhibitor.getCountyCode(),"Sheeat",true));
        allVals=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());
        people.setText(allVals.toString());
         queryTable="exhibitagegendercountyscores";
        queryGrid=" and exhibitagegendercountyscores.gender= '" + exhibitor.getGender()+ "' and exhibitagegendercountyscores.countyCode=" + exhibitor.getCountyCode() + " order by age";
    }


    else if(exhibitor.getGender()!='N' && exhibitor.getAge()!=-1 && exhibitor.getCountyCode()==-1)
    {

        qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where " + getAgeQuery() + " and " + getGenderQuery(),"Sheeat",true));
        genage=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());

        people.setText(genage.toString());
         queryTable="exhibitagegenderscores";
        queryGrid=" and exhibitagegenderscores.gender= '" + exhibitor.getGender()+ "' order by age";
    }
     else if(exhibitor.getGender()=='N' && exhibitor.getAge()!=-1 && exhibitor.getCountyCode()!=-1)
    {

       qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where " + getAgeQuery() +  " and countyCode= " + exhibitor.getCountyCode(),"Sheeat",true));
       agecounty=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());

        people.setText(agecounty.toString());
         queryTable="exhibitagecountyscores";
        queryGrid=" and exhibitagecountyscores.countyCode= " + exhibitor.getCountyCode() + " order by age";
    }
    else if(exhibitor.getGender()!='N' && exhibitor.getAge()==-1 && exhibitor.getCountyCode()!=-1)
    {

       qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where countyCode= " + exhibitor.getCountyCode() + " and " + getGenderQuery(),"Sheeat",true));
       gencounty=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());

        people.setText(gencounty.toString());
        queryTable="exhibitgendercountyscores";
        queryGrid=" and exhibitgendercountyscores.gender = '" + exhibitor.getGender() + "' and exhibitgendercountyscores.countyCode= " + exhibitor.getCountyCode();
    }
     else if(exhibitor.getGender()!='N' && exhibitor.getAge()==-1 && exhibitor.getCountyCode()==-1)
    {

        qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where " + getGenderQuery(),"Sheeat",true));
        gen=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());

        people.setText(gen.toString());
        queryTable="exhibitgenderscores";
        queryGrid=" and exhibitgenderscores.gender = '" + exhibitor.getGender() + "'";
    }
     else if(exhibitor.getGender()=='N' && exhibitor.getAge()==-1 && exhibitor.getCountyCode()!=-1)
    {

        qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where countyCode= " + exhibitor.getCountyCode(),"Sheeat",true));
        countyVal=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());

        people.setText(countyVal.toString());
        queryTable="exhibitcountyscores";
        queryGrid=" and exhibitcountyscores.countyCode = " + exhibitor.getCountyCode();
    }
    else if(exhibitor.getGender()=='N' && exhibitor.getAge()!=-1 &&exhibitor.getCountyCode()==-1)
    {

        qr= this.asi.performQuery(new QueryReplyRequest("select count(id) from exhibitor where " + getAgeQuery(), "Sheeat",true));
        ageVal=new Integer(qr.getResults().getColumn(1).elementAt(0).toString());

        people.setText(ageVal.toString());
        queryGrid="order by age;";
        queryTable="exhibitagescores";
    }
    else
    {   people.setText(total.getText());
        queryGrid="";
        queryTable="exhibitallscores";
    }






  }
  void setUpDiploma()
  {    int numSelected=0;
    if(numCols!=1 || gender.isSelected() || age.isSelected() || county.isSelected())
    {
      valString="Who is";
      if(gender.isSelected())
        numSelected++;
      if(age.isSelected())
        numSelected++;
      if(county.isSelected())
        numSelected++;
      if(gender.isSelected())
      {
          if(exhibitor.getGender()=='M')
            valString+=" Male";
          else
            valString+=" Female";
        if(numSelected >1 || numCols!=1)
          valString+=",";
      }
      if(county.isSelected())
      { valString+=" from " + countyCodes.get(new Integer((int)exhibitor.getCountyCode())) + " County";
        if(numSelected >1 || numCols!=1)
          valString+=",";
      }
      if(age.isSelected())
      {
          valString+=" " + minAge + " to " + maxAge + " Years Old";
          if(numSelected >1 || numCols!=1)
            valString+=",";
      }
    valString+=" With";
    }
    else
      valString="With";


      int dataPos;
      for(int i=0;i<numCols;i++)
      { System.out.println("Name is " + table.getColumnName(i));
        for(dataPos=0;dataPos<lbls.size();dataPos++)
         { if(((String)columnNames.elementAt(dataPos)).compareTo(table.getColumnName(i))==0)
            break;
          }
        if(numCols!=1 && i!=numCols-1 && numCols!=2)
          valString+=" " + table.getColumnName(i) + " of" + ((Vector)dataVec.elementAt(0)).elementAt(dataPos) + ",";
        else if(numCols==2 && i!=numCols-1)
          valString+=" " + table.getColumnName(i) + " of" + ((Vector)dataVec.elementAt(0)).elementAt(dataPos);
        else if(numCols!=1 && i==numCols-1)
           valString+=" and " + table.getColumnName(i) + " of " + ((Vector)dataVec.elementAt(0)).elementAt(dataPos);

        else
           valString+=" " + table.getColumnName(i) + " of" + ((Vector)dataVec.elementAt(0)).elementAt(dataPos);

      }
      vwDip.setEnabled(true);
      vwDip.setVisible(true);
      instr2.setText("Congratulations! You found a combination of measurements that makes you unique!  Press the button below to see your diploma.");





 }

}