
/**
 * Title:        Devices for Measure Me<p>
 * Description:  Device Wrapppers/Code for measure me.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
//package analysis;
package edu.ucf.cs.dml.simnets.measureme.client;

public class BalanceValueMap extends ValueMap
{ protected int uppertime=60;

  public BalanceValueMap() {
    super();
  }

  /**
   * If time balanced is greater than or equal to one minute, return 255.  Otherwise,
   * the internal value is the fraction of a minute times 255.
   * @param parm1
   * @return
   */
  public Short getInternalValue(Object parm1)
  { Long delta=(Long) parm1;
        //System.out.println((((double) delta.longValue()/1000)/((double)this.uppertime) * 255));
    if((delta.longValue()/(this.uppertime*1000))>=1)
     return new Short((short)255);
    else
     return new Short( (short)  (((double) delta.longValue()/1000)/((double)this.uppertime) * 255));

  }

  public Object getActualValue(Short parm1)
  { return new Float(((float)parm1.shortValue())/((float)255) * this.uppertime);
    //TODO: implement this edu.ucf.cs.dml.simnets.measureme.client.ValueMap abstract method
  }

  public String getMetricUnits()
  { return "s";
    //TODO: implement this edu.ucf.cs.dml.simnets.measureme.client.ValueMap abstract method
  }
}