
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import edu.ucf.cs.dml.mapthing.GraphicHotSpot;
import java.awt.event.*;

public class CharacterHotSpot extends GraphicHotSpot
{
  BorderLayout borderLayout1 = new BorderLayout();
  private String introductoryDisplayText="";

  public CharacterHotSpot()
  {
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

  }

  public String getIntroductoryDisplayText()
  {
    return introductoryDisplayText;
  }

  public void setIntroductoryDisplayText(String newIntroductoryDisplayText)
  {
    introductoryDisplayText = newIntroductoryDisplayText;
    this.item.setText(introductoryDisplayText+" "+this.getDisplayName());
  }

  public void setDisplayName(String newDisplayName) {
    super.setDisplayName(newDisplayName);
    this.item.setText(introductoryDisplayText+" "+newDisplayName);
  }

  private void jbInit() throws Exception
  {
    this.addMouseListener(new java.awt.event.MouseAdapter()
    {

      public void mouseClicked(MouseEvent e)
      {
        this_mouseClicked(e);
      }
    });
  }

  void this_mouseClicked(MouseEvent e)
  { //this.dispatchEvent(e);

  }



}