
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import com.borland.jbcl.control.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.lang.reflect.*;
import java.util.*;
import edu.ucf.cs.dml.mapthing.*;
import java.net.*;

public class ChooseAvatarPanel extends MapAreaPanel
{
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  ImageIcon icon1=null;
  ImageIcon icon2=null;
  TransparentImage transparentImage1 = new TransparentImage();
  TransparentImage transparentImage2 = new TransparentImage();
  JLabel jLabel2 = new JLabel();
  // these two must be public; otherwise
  //    the MapAreaPanel constructor can't get access to these variables
  public GraphicHotSpot graphicHotSpot1 = new GraphicHotSpot();
  public GraphicHotSpot graphicHotSpot2 = new GraphicHotSpot();
  JLabel jLabel3 = new JLabel();
  GuiParameters gp;

  public ChooseAvatarPanel(GuiParameters gp)
  {
    super();
    this.gp = gp;
    System.out.println("Number of CharacterHotSpots: " + hotSpotCount);
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception
  { icon1=new ImageIcon((URL)gp.getParameter("baseURL"), "avatars/boy_blob.gif");
    icon2=new ImageIcon((URL)gp.getParameter("baseURL"), "avatars/girl_blob.gif");

    this.setLayout(xYLayout1);
    jLabel1.setFont(new java.awt.Font("SansSerif", 1, 26));
    jLabel1.setText("Welcome! You are about to begin a quest to discover... YOU!");
    jLabel2.setFont(new java.awt.Font("SansSerif", 1, 26));
    jLabel2.setToolTipText("");
    jLabel2.setText("Before we start, please choose a guide character:");
    //transparentImage1.setImageName("C:\\mmanim\\avatars\\boy_blob.gif");
    //transparentImage2.setImageName("C:\\mmanim\\avatars\\girl_blob.gif");
    graphicHotSpot1.setDisplayPopup(Boolean.FALSE);
    graphicHotSpot1.setDisplayName("Boy");
    graphicHotSpot2.setDisplayPopup(Boolean.FALSE);
    graphicHotSpot2.setDisplayName("Girl");
    jLabel3.setFont(new java.awt.Font("SansSerif", 1, 28));
    jLabel3.setText("Please double click on the guide character that you like!");
    transparentImage1.setDrawEdge(false);
    transparentImage2.setDrawEdge(false);
    this.add(jLabel1, new XYConstraints(26, 25, -1, -1));
    this.add(jLabel2, new XYConstraints(96, 65, -1, -1));
    this.transparentImage1.setImageURL(new java.net.URL((URL)gp.getParameter("baseURL"), "avatars/boy_blob.gif"));
    this.transparentImage2.setImageURL(new java.net.URL((URL)gp.getParameter("baseURL"), "avatars/girl_blob.gif"));
    //this.transparentImage1.setImage(icon1.getImage());
    //this.transparentImage2.setImage(icon2.getImage());

    this.add(graphicHotSpot1, new XYConstraints(186, 181, 129, 134));
    this.add(graphicHotSpot2, new XYConstraints(493, 185, 164, 138));
    this.add(transparentImage1, new XYConstraints(180, 173, -1, -1));
    this.add(transparentImage2, new XYConstraints(487, 173, -1, -1));
    this.add(jLabel3, new XYConstraints(24, 410, -1, -1));
  }

/*
  public synchronized void addMapAreaSelectedListener(MapAreaSelectedListener l)
  { if(!registered) //we have not registered the hotspot sub listeners
    {
      for(int i=0; i<hotSpotCount;i++)
      {GraphicHotSpot hs=null;
        try{
         hs=(GraphicHotSpot) ((Field)hotSpots.elementAt(i)).get(this);
         }
        catch(Exception e)
        { e.printStackTrace();
        }
        if(hs==null)
        {System.out.println("null at "+i);
        }

        hs.addMouseListener(mapAdapt);

        registered=true;

       // hs.addMouseListener(new Mouse);
      }
    }
    Vector v = mapAreaSelectedListeners == null ? new Vector(2) : (Vector) mapAreaSelectedListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      mapAreaSelectedListeners = v;
    }
  }
*/


}