package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class GripValueMap extends ValueMap
{

  public GripValueMap()
  {
  }


  public String getMetricUnits()
  {
    return "lbs";
  }
  public Object getActualValue(Short deviceValue)
  { return deviceValue;

  }
  public Short getInternalValue(Object actualValue)
  {  /* translate the integer into a 0..255*/
    Short s=(Short)actualValue;
    if(s.shortValue() <255)
      return s;
    return new Short((short)255);


  }
}