package edu.ucf.cs.dml.simnets.measureme.client;

import java.util.*;

/**
 * Contains GUI parameters like instruction text and if the
 * device is deviceActivated or not.
 */
public class GuiParameters implements java.io.Serializable {
  /**
   * Maps Strings to Objects.
   */
  protected Hashtable parameters = null;

  public GuiParameters() {
    parameters = new Hashtable();
  }

  public void addToParameters(String parameterName, Object serializableObject) {
    parameters.put(parameterName, serializableObject);
  }

  public Object getParameter(String parameterName) {
    return parameters.get(parameterName);
  }

  public Enumeration getParameterNames() {
    return parameters.keys();
  }

} // GuiParameters