package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

import java.io.*;
import edu.ucf.cs.dml.simnets.measureme.devices.GrayCodeCalibrationData;

public class ManualGrayCodeCalibration
{

  public ManualGrayCodeCalibration()
  {
  }
  public static void main(String[] args)
  {
    ManualGrayCodeCalibration mgc = new ManualGrayCodeCalibration();
    File f=new File("C:\\greycodecalibration.ser");
    try{
     FileOutputStream fos=new FileOutputStream(f);
     ObjectOutputStream oos=new ObjectOutputStream(fos);
     GrayCodeCalibrationData data= new GrayCodeCalibrationData();
     data.setZeroValue((short) 110);

     oos.writeObject(data);
     oos.close();
    }
    catch(Exception e2)
    { System.out.println("Error on file write!");

    }
  }
}