
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import edu.ucf.cs.dml.mapthing.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.net.URL;

public class OSCWorldPanel extends JPanel implements WorldMapCallbackInterface
{
  XYLayout xYLayout1 = new XYLayout();
  TheWorldPanel theWorldPanel1 = null;
  JLabel jLabel1 = new JLabel();
  URL baseURL=null;
  WorldMapCallbackInterface callback=null;

  public OSCWorldPanel(WorldMapCallbackInterface callback, URL baseURL)
  { this.callback=callback;
    this.baseURL=baseURL;
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception
  {
    this.setLayout(xYLayout1);
    jLabel1.setFont(new java.awt.Font("SansSerif", 1, 26));
    jLabel1.setText("Please choose the place where you live!");
    theWorldPanel1=new TheWorldPanel(this,baseURL);
    this.add(theWorldPanel1, new XYConstraints(90, 100, 620, 400));
    this.add(jLabel1, new XYConstraints(153, 28, -1, -1));
  }

  public void areaSelected(String area)
  { callback.areaSelected(area);

  }

  public void finalAreaSelected(String area)
  { callback.finalAreaSelected(area);

  }

  public void reset()
  { this.theWorldPanel1.resetWorld();
  }




}