package edu.ucf.cs.dml.simnets.measureme.client;
import edu.ucf.cs.dml.simnets.measureme.server.*;
import edu.ucf.cs.dml.simnets.measureme.devices.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import com.borland.jbcl.control.*;
import net.jini.core.lease.Lease;
import net.jini.space.JavaSpace;
import java.net.*;
import java.util.*;
import java.io.*;
import java.lang.reflect.*;
import java.beans.*;
import javax.swing.border.*;

public class ParameterMakerFrame extends JFrame implements Runnable {
  XYLayout xYLayout1 = new XYLayout();
  JButton takeBn = new JButton();
  JButton openBn = new JButton();
  JButton writeBn = new JButton();
  JButton saveBn = new JButton();
  Filer filer1 = new Filer();
  Filer filer2 = new Filer();
  JButton clearBn = new JButton();
  JavaSpace javaSpace=null;
  HashMap currentTable = new HashMap();
  StationParameters currentParameters=null;
  Device currentDevice=null;
  ValueMap currentValueMap=null;
  DeviceProxy currentDeviceProxy=null;
  int count = 0;
  JPanel jPanel1 = new JPanel();
  FlowLayout flowLayout1 = new FlowLayout();
  JPanel jPanel3 = new JPanel();
  GridLayout gridLayout1 = new GridLayout();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel2 = new JPanel();
  FlowLayout flowLayout2 = new FlowLayout();
  TitledBorder titledBorder3;
  TitledBorder titledBorder4;
  TitledBorder titledBorder5;
  JPanel jPanel5 = new JPanel();
  JPanel jPanel6 = new JPanel();
  JTextField proxyNameField = new JTextField();
  JTextField keyField = new JTextField();
  JRadioButton intRadioBn = new JRadioButton();
  JComboBox paramNameCombo = new JComboBox();
  JLabel valueLabel = new JLabel();
  JRadioButton stringRadioBn = new JRadioButton();
  JLabel keyLabel = new JLabel();
  JTextField valueMapNameField = new JTextField();
  JTextField devNameField = new JTextField();
  JRadioButton urlRadioBn = new JRadioButton();
  JButton delBn = new JButton();
  JTextField stationNameField = new JTextField();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JButton acceptBn = new JButton();
  XYLayout xYLayout2 = new XYLayout();
  XYLayout xYLayout3 = new XYLayout();
  ButtonGroup bg = new ButtonGroup();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea valueField = new JTextArea();
  JLabel statusLabel = new JLabel();
  final String ADDED_ITEMS_ITEM = "Added Items";

  public ParameterMakerFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      Thread t=new Thread(this);
      t.start();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  } // constructor

  private void jbInit() throws Exception {
    clearBn.setToolTipText("Start over");
    acceptBn.setToolTipText("Save key value pair");
    delBn.setToolTipText("Remove key value pair");
    jScrollPane1.setBorder(null);
    jScrollPane1.setMaximumSize(new Dimension(4, 21));
    jScrollPane1.setMinimumSize(new Dimension(4, 21));
    jScrollPane1.setNextFocusableComponent(devNameField);
    paramNameCombo.addItem(this.ADDED_ITEMS_ITEM);
    valueField.setBorder(BorderFactory.createLoweredBevelBorder());
    valueField.setLineWrap(true);
    valueField.setWrapStyleWord(true);
    valueField.setMaximumSize(new Dimension(4, 21));
    jPanel1.setMaximumSize(new Dimension(153, 65));
    jPanel2.setMaximumSize(new Dimension(155, 65));
    jPanel4.setMaximumSize(new Dimension(85, 65));
    jPanel5.setMaximumSize(new Dimension(467, 324));
    stationNameField.setMaximumSize(new Dimension(4, 21));
    keyField.setMaximumSize(new Dimension(4, 21));
    proxyNameField.setMaximumSize(new Dimension(4, 21));
    devNameField.setMaximumSize(new Dimension(4, 21));
    valueMapNameField.setMaximumSize(new Dimension(4, 21));
    paramNameCombo.setMaximumSize(new Dimension(125, 21));
    paramNameCombo.setMinimumSize(new Dimension(125, 21));
    jPanel3.setMaximumSize(new Dimension(4, 4));
    statusLabel.setMaximumSize(new Dimension(4, 4));
    statusLabel.setMinimumSize(new Dimension(4, 4));
    statusLabel.setPreferredSize(new Dimension(4, 4));
    jPanel6.setMaximumSize(new Dimension(494, 464));
    jPanel6.setMinimumSize(new Dimension(494, 464));
    jPanel6.setPreferredSize(new Dimension(494, 464));
    bg.add(this.intRadioBn);
    bg.add(this.stringRadioBn);
    bg.add(this.urlRadioBn);
    jPanel5.setLayout(xYLayout2);
    acceptBn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        acceptBn_actionPerformed(e);
      }
    });
    acceptBn.setText("Accept");
    jLabel3.setText("Station Name");
    jLabel5.setText("Device Class");
    jLabel6.setText("Device Proxy Class");
    jLabel7.setText("Value Map Class");
    stationNameField.setNextFocusableComponent(keyField);
    delBn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        delBn_actionPerformed(e);
      }
    });
    delBn.setText("Delete");
    urlRadioBn.setText("URL");
    devNameField.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        devNameField_actionPerformed(e);
      }
    });
    devNameField.setNextFocusableComponent(proxyNameField);
    valueMapNameField.setNextFocusableComponent(stationNameField);
    keyLabel.setText("Key");
    stringRadioBn.setText("String");
    valueLabel.setText("Value");
    intRadioBn.setText("Integer");
    intRadioBn.setSelected(true);
    proxyNameField.setNextFocusableComponent(valueMapNameField);

    titledBorder3 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Filesystem");
    titledBorder4 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"JavaSpace");
    titledBorder5 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Panel");
    jPanel1.setBorder(titledBorder4);
    jPanel1.setLayout(flowLayout1);
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    jPanel3.setLayout(gridLayout1);
    jPanel4.setBorder(titledBorder5);
    jPanel2.setLayout(flowLayout2);
    jPanel2.setBorder(titledBorder3);
    jPanel6.setLayout(xYLayout3);
    this.getContentPane().setLayout(xYLayout1);
    this.setTitle("Station Parameters Tool");
    takeBn.setEnabled(false);
    writeBn.setEnabled(false);
    takeBn.setMaximumSize(new Dimension(63, 27));
    takeBn.setMinimumSize(new Dimension(63, 27));
    takeBn.setPreferredSize(new Dimension(63, 27));
    takeBn.setToolTipText("Take StationParameters object from JavaSpace");
    takeBn.setText("Take");
    takeBn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        takeBn_actionPerformed(e);
      }
    });
    openBn.setToolTipText("Load StationParameters object from disk");
    openBn.setText("Open");
    openBn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        openBn_actionPerformed(e);
      }
    });
    writeBn.setText("Write");
    writeBn.setToolTipText("Write StationParameters object to JavaSpace");
    writeBn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        writeBn_actionPerformed(e);
      }
    });
    saveBn.setMaximumSize(new Dimension(63, 27));
    saveBn.setMinimumSize(new Dimension(63, 27));
    saveBn.setPreferredSize(new Dimension(63, 27));
    saveBn.setToolTipText("Write StationParameters object to disk");
    saveBn.setText("Save");
    saveBn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        saveBn_actionPerformed(e);
      }
    });
    filer2.setFrame(this);
    filer1.setFrame(this);
    filer2.setMode(Filer.SAVE);
    xYLayout1.setHeight(464);
    xYLayout1.setWidth(494);

    paramNameCombo.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        paramNameCombo_itemStateChanged(e);
      }
    });


    clearBn.setMaximumSize(new Dimension(65, 27));
    clearBn.setMinimumSize(new Dimension(65, 27));
    clearBn.setPreferredSize(new Dimension(65, 27));
    clearBn.setText("Clear");
    clearBn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        clearBn_actionPerformed(e);
      }
    });

    jPanel5.setBorder(BorderFactory.createEtchedBorder());
    jPanel6.add(jPanel1, new XYConstraints(8, 10, 156, 67));
    jPanel1.add(takeBn, null);
    jPanel1.add(writeBn, null);
    jPanel6.add(jPanel2, new XYConstraints(169, 10, 157, 67));
    jPanel2.add(openBn, null);
    jPanel2.add(saveBn, null);
    jPanel6.add(jPanel4, new XYConstraints(330, 9, 156, 68));
    jPanel4.add(clearBn, null);
    jPanel6.add(jPanel5, new XYConstraints(9, 83, 475, 334));
    jPanel5.add(jLabel3, new XYConstraints(7, 11, -1, -1));
    jPanel5.add(stationNameField, new XYConstraints(90, 9, 173, -1));
    jPanel5.add(keyLabel, new XYConstraints(7, 58, -1, -1));
    jPanel5.add(valueLabel, new XYConstraints(6, 87, -1, -1));
    jPanel5.add(keyField, new XYConstraints(49, 57, 173, -1));
    jPanel5.add(proxyNameField, new XYConstraints(123, 273, 340, -1));
    jPanel5.add(jLabel5, new XYConstraints(6, 248, -1, -1));
    jPanel5.add(devNameField, new XYConstraints(123, 248, 340, -1));
    jPanel5.add(jLabel7, new XYConstraints(6, 301, -1, -1));
    jPanel5.add(valueMapNameField, new XYConstraints(123, 299, 340, -1));
    jPanel5.add(jLabel6, new XYConstraints(6, 275, -1, -1));
    jPanel5.add(jScrollPane1, new XYConstraints(49, 87, 414, 62));
    jScrollPane1.getViewport().add(valueField, null);
    jPanel5.add(intRadioBn, new XYConstraints(49, 164, -1, -1));
    jPanel5.add(stringRadioBn, new XYConstraints(49, 185, -1, -1));
    jPanel5.add(urlRadioBn, new XYConstraints(49, 206, -1, -1));
    jPanel5.add(acceptBn, new XYConstraints(136, 169, -1, -1));
    jPanel5.add(delBn, new XYConstraints(137, 201, -1, -1));
    jPanel5.add(paramNameCombo, new XYConstraints(243, 186, 196, -1));
    jPanel6.add(jPanel3, new XYConstraints(9, 427, 476, 25));
    jPanel3.add(statusLabel, null);
    this.getContentPane().add(jPanel6);
    this.setSize(new Dimension(500, 486));
    this.validate();

    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = this.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    this.setVisible(true);
  } // jbInit

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  } // processWindowEvent

  public void run() {
    try {
      javaSpace=MMSpaceAccessor.getSpace();
      takeBn.setEnabled(true);
      writeBn.setEnabled(true);
    }
    catch (Exception e) {
      e.printStackTrace();
      statusLabel.setText("Exception!");
    }
  } // run

  void clearBn_actionPerformed(ActionEvent e) {
    System.out.println("clearBn_actionPerformed()");
    currentTable.clear();
    paramNameCombo.removeAllItems();
    paramNameCombo.addItem(this.ADDED_ITEMS_ITEM);
    count = 0;
    devNameField.setText("");
    proxyNameField.setText("");
    valueMapNameField.setText("");
    stationNameField.setText("");
    keyField.setText("");
    valueField.setText("");
    statusLabel.setText("");
  } // clearBn_actionPerformed

  void openBn_actionPerformed(ActionEvent e) {
    System.out.println("openBn_actionPerformed()");
    statusLabel.setText("");
    filer1.setVisible(true);
    count = 0;
    String directoryName = filer1.getDirectory();
    String fName = filer1.getFile();
    System.out.println(directoryName);
    System.out.println(fName);
    if (fName != null) {
      StationParameters p=loadParamFile(directoryName,fName);
      if(p != null) {
        readFrom(p);

      }
    }
  } // openBn_actionPerformed

  protected StationParameters loadParamFile(String directory, String fileName) {
    System.out.println("loadParamFile()");
    File f = new File(directory + fileName);
    StationParameters p = null;
    try {
      FileInputStream fis = new FileInputStream(f);
      ObjectInputStream ois = new ObjectInputStream(fis);
      try {
        p = (StationParameters) ois.readObject();
      }
      catch (InvalidClassException e1) {
        statusLabel.setText("Error: Serialized file can't be unserialized using local class.");
      }
      fis.close();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    return p;
  } // loadParamFile

  protected void readFrom(StationParameters sp) {
    System.out.println("readFrom()");
    currentParameters=sp;
    currentTable.clear();
    GuiParameters gp = sp.getGuiParameters();
    paramNameCombo.removeAllItems();
    paramNameCombo.addItem(this.ADDED_ITEMS_ITEM);
    count=0;
    if (gp == null) {System.out.println("  gp was null");}
    System.out.println("  station name: "+sp.getStationName());
    stationNameField.setText(sp.getStationName());
    devNameField.setText(sp.getDeviceName());
    proxyNameField.setText(sp.getDeviceProxyName());
    valueMapNameField.setText(sp.getValueMapName());
    Enumeration enum = gp.getParameterNames();
    String stgName=null;
    while(enum.hasMoreElements()) {
      stgName = (String) enum.nextElement();
      currentTable.put(stgName, gp.getParameter(stgName));
      paramNameCombo.addItem(stgName);
    }
  } // readFrom

  void takeBn_actionPerformed(ActionEvent e) {
    System.out.println("takeBn_actionPerformed()");
    statusLabel.setText("");
    if (stationNameField.getText().equals("")) {
      statusLabel.setText("Error: Need a station name.");
      return;
    }
    if (javaSpace==null) {
      statusLabel.setText("Error: No JavaSpace.");
      return;
    }
    StationParameters template = new StationParameters();
    template.setStationName(stationNameField.getText());
    StationParameters p = null;
    try {
      p = (StationParameters) javaSpace.takeIfExists(template, null, Long.MAX_VALUE);
    }
    catch (Exception e2) {
      e2.printStackTrace();
      statusLabel.setText("Exception");
    }

    if (p != null) {
      System.out.println("  found: "+p.toString());
      readFrom(p);
    }
    else {
      statusLabel.setText("No matching entry found.");
    }
  } // takeBn_actionPerformed

  void writeBn_actionPerformed(ActionEvent e) {
    System.out.println("writeBn_actionPerformed()");
    statusLabel.setText("");
    // make sure a tuple isn't already in the space
    if (stationNameField.getText().equals("")) {
      statusLabel.setText("Error: Need a station name.");
      return;
    }
    if (javaSpace==null) {
      statusLabel.setText("Error: No JavaSpace.");
      return;
    }
    StationParameters template = new StationParameters();
    template.stationName = stationNameField.getText();
    try {
      StationParameters p = (StationParameters) javaSpace.takeIfExists(template,
                                                null, Long.MAX_VALUE);
      if (p != null) {System.out.println("  removed old parameter object");}
    }
    catch (Exception e1) {
      statusLabel.setText("Exception!");
      return;
    }
    StationParameters sp = readInto();
    System.out.println("  just ran readInto; station name: "+sp.getStationName());
    if (sp != null) {
      if (javaSpace != null) {
        try {
          javaSpace.write(sp, null, Lease.FOREVER);
          System.out.println("  wrote new station parameters");
        }
        catch(Exception e2) {
          e2.printStackTrace();
          statusLabel.setText("Exception!");
        }
      }
      else {
        statusLabel.setText("Error: No JavaSpace.");
      }
    }
  } // writeBn_actionPerformed

  protected StationParameters readInto() {
    System.out.println("readInto()");
    try {
      Class.forName(devNameField.getText());
    }
    catch(Exception e) {
      statusLabel.setText("Error: Invalid device class.");
      return null;
    }

    try {
      Class.forName(proxyNameField.getText());
    }
    catch(Exception e) {
      statusLabel.setText("Error: Invalid device proxy class.");
      return null;
    }

    try {
      Class.forName(valueMapNameField.getText());
    }
    catch (Exception e) {
      statusLabel.setText("Error: Invalid value map class.");
      return null;
    }

    GuiParameters gp = new GuiParameters();
    if (gp == null) {System.out.println("  gp was null");}
    Iterator itr = currentTable.keySet().iterator();
    String nameStr = null;
    while (itr.hasNext()) {
      nameStr = (String) itr.next();
      // null values mean entry has been deleted; see delBn_actionPerformed
      if (currentTable.get(nameStr) != null) {
        gp.addToParameters(nameStr, currentTable.get(nameStr));
        System.out.println("added "+nameStr+" to gp");
      }
    }
    StationParameters sp = new StationParameters();
    sp.setStationName(stationNameField.getText());
    sp.setDeviceName(devNameField.getText());
    sp.setDeviceProxyName(proxyNameField.getText());
    sp.setValueMapName(valueMapNameField.getText());
    sp.setGuiParameters(gp);
    System.out.println("  "+sp.getGuiParameters());
    return sp;
  } // readInto

  void saveBn_actionPerformed(ActionEvent e) {
    System.out.println("saveBn_actionPerformed()");
    statusLabel.setText("");
    StationParameters sp = readInto();
    if (sp != null) {
      filer2.setVisible(true);
      if (filer2.getFile() != null) {
        File f = new File(filer2.getDirectory()+filer2.getFile());
        try {
          FileOutputStream fos = new FileOutputStream(f);
          ObjectOutputStream oos = new ObjectOutputStream(fos);
          oos.writeObject(sp);
          fos.close();
        }
        catch(Exception e2) {
          e2.printStackTrace();
          statusLabel.setText("Exception!");
        }
      }
    }
  } // saveBn_actionPerformed

  void acceptBn_actionPerformed(ActionEvent e) {
    System.out.println("acceptBn_actionPerformed()");
    statusLabel.setText("");
    if (!keyField.getText().equals("")) {
      if (urlRadioBn.isSelected()) {
        System.out.println("  url button selected");
        URL url;
        try {
          url = new URL(valueField.getText());
        }
        catch (MalformedURLException e1) {
          statusLabel.setText("Error: Invalid URL.");
          return;
        }
        if (!currentTable.containsKey(keyField.getText())) {
          paramNameCombo.addItem(keyField.getText());
        }
        currentTable.put(keyField.getText(), url);
      }
      if (intRadioBn.isSelected()) {
        System.out.println("  integer button selected");
        int num = 0;
        try {
          num = Integer.parseInt(valueField.getText());
        }
        catch (NumberFormatException e1) {
          statusLabel.setText("Error: Not an integer.");
          return;
        }
        if (!currentTable.containsKey(keyField.getText())) {
          paramNameCombo.addItem(keyField.getText());
        }
        currentTable.put(keyField.getText(), new Integer(num));
      }
      if (stringRadioBn.isSelected()) {
        System.out.println("  string button selected");
        if(!currentTable.containsKey(keyField.getText())) {
          System.out.println("  table doesn't contain "+keyField.getText());
          paramNameCombo.addItem(keyField.getText());
          System.out.println("  added item to combo box");
        }
        currentTable.put(keyField.getText(),valueField.getText());
        System.out.println("  added item to table");
      }
      paramNameCombo.setSelectedItem(this.ADDED_ITEMS_ITEM);
      keyField.setText("");
      valueField.setText("");
    }
  } // acceptBn_actionPerformed

  void paramNameCombo_itemStateChanged(ItemEvent e) {
    System.out.println("paramNameCombo_itemStateChanged()");
    String selectedItem = (String) paramNameCombo.getSelectedItem();
    // when we removeAllItems from the combo box, null will be fired
    // as the selectedItem on the last update; ignore it
    if (selectedItem == null) {return;}
    // if "Added Items" is selected or added, just reset fields and exit
    if (selectedItem == ADDED_ITEMS_ITEM) {
      keyField.setText("");
      valueField.setText("");
      return;
    }
    Object o = currentTable.get(selectedItem);
    System.out.println("  selectedItem in combo box: "+selectedItem);
    keyField.setText((String) paramNameCombo.getSelectedItem());
    valueField.setText(o.toString());
    if (o instanceof String) {
      stringRadioBn.setSelected(true);
    }
    if (o instanceof java.net.URL) {
      urlRadioBn.setSelected(true);
    }
    if (o instanceof Integer) {
      intRadioBn.setSelected(true);
    }
  } // paramNameCombo_itemStateChanged


  void delBn_actionPerformed(ActionEvent e) {
    System.out.println("delBn_actionPerformed()");
    statusLabel.setText("");
    String key = (String) currentTable.get(keyField.getText());
    if (key != null) {
      // since I can't figure out why HashMap.remove doesn't work
      // I'm simply setting this key's value to null; I'll check
      // for null in readInto
      currentTable.put(key, null);
      System.out.println("deleted items new value: "+currentTable.get(key));
      paramNameCombo.removeItem(keyField.getText());
    }
    paramNameCombo.setSelectedItem(this.ADDED_ITEMS_ITEM);
    keyField.setText("");
    valueField.setText("");
  } // delBn_actionPerformed

  void devNameField_actionPerformed(ActionEvent e) {
    System.out.println("devNameField_actionPerformed()");
    proxyNameField.setText(devNameField.getText()+"Proxy");
    valueMapNameField.setText("edu.ucf.cs.dml.simnets.measureme.client."+ripSpaces(this.stationNameField.getText())+"ValueMap");
  } // devNameField_actionPerformed

  protected String ripSpaces(String stringToRip) {
    System.out.println("ripSpaces()");
    String localStr = new String(stringToRip);
    if(localStr.indexOf(" ")>-1) {
      return ripSpaces(localStr.substring(0,localStr.indexOf(" "))+localStr.substring(localStr.indexOf(" ")+1)) ;
    }
    else {
      return localStr;
    }
  } // ripSpaces

} // ParameterMakerFrame
