package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import com.borland.jbcl.control.*;

public class TestCurveApplet extends JApplet
{
  boolean isStandalone = false;
  XYLayout xYLayout1 = new XYLayout();
  CurvePanel curvePanel1 = new CurvePanel();
  JButton addDataBn = new JButton();
  TransparentImage transparentImage1 = new TransparentImage();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();

  //Get a parameter value
  public String getParameter(String key, String def)
  {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public TestCurveApplet()
  {
  }

  //Initialize the applet
  public void init()
  {
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception
  {
    this.setSize(new Dimension(800,600));
    this.getContentPane().setLayout(xYLayout1);
    addDataBn.setText("Add Data");
    jLabel1.setText("A quick test of  data set rendering. The add data button simply adds " +
    "3, to the dataset, in a random score.");
    jLabel2.setText("The score range labeling is due to change.");
    this.getContentPane().add(curvePanel1, new XYConstraints(194, 94, -1, -1));
    this.getContentPane().add(addDataBn, new XYConstraints(705, 61, -1, -1));
    this.getContentPane().add(transparentImage1, new XYConstraints(3, 173, -1, -1));
    this.getContentPane().add(jLabel1, new XYConstraints(118, 13, -1, -1));
    this.getContentPane().add(jLabel2, new XYConstraints(283, 31, -1, -1));
  }

  //Start the applet
  public void start()
  {
  }

  //Stop the applet
  public void stop()
  {
  }

  //Destroy the applet
  public void destroy()
  {
  }

  //Get Applet information
  public String getAppletInfo()
  {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo()
  {
    return null;
  }

  //Main method
  public static void main(String[] args)
  {
    TestCurveApplet applet = new TestCurveApplet();
    applet.isStandalone = true;
    JFrame frame = new JFrame();
    //EXIT_ON_CLOSE == 3
    frame.setDefaultCloseOperation(3);
    frame.setTitle("Applet Frame");
    frame.getContentPane().add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(800,620);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

  //static initializer for setting look & feel
  static
  {
    try
    {
      //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch(Exception e)
    {
    }
  }
}