
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.awt.event.*;

public class TestTrombone extends JFrame
{
  XYLayout xYLayout1 = new XYLayout();
  TrombonePanel trombonePanel1=null;
 boolean packFrame = false;
  JButton pitchBendBn = new JButton();
  JButton noteChangeBn = new JButton();
  public TestTrombone()
  {

    try
    { trombonePanel1 = new TrombonePanel();
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public static void main(String[] args)
  {
    TestTrombone testTrombone = new TestTrombone();
    TestTrombone frame=testTrombone;
    frame.setSize(800,600);
     if (false)
    {
      frame.pack();
    }
    else
    {
      frame.validate();
    }
    //Center the window

    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height)
    {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width)
    {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  private void jbInit() throws Exception
  {
    xYLayout1.setWidth(800);
    xYLayout1.setHeight(600);
    this.getContentPane().setLayout(xYLayout1);
    trombonePanel1.setMinimumSize(new Dimension(571, 130));
    trombonePanel1.setPreferredSize(new Dimension(571, 130));
    pitchBendBn.setEnabled(false);
    pitchBendBn.setText("Pitch Bend");
    pitchBendBn.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        pitchBendBn_actionPerformed(e);
      }
    });
    noteChangeBn.setText("Note change");
    noteChangeBn.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        noteChangeBn_actionPerformed(e);
      }
    });
    this.getContentPane().add(trombonePanel1, new XYConstraints(7, 12, -1, -1));
    this.getContentPane().add(pitchBendBn, new XYConstraints(63, 243, -1, -1));
    this.getContentPane().add(noteChangeBn, new XYConstraints(284, 243, -1, -1));
  }

  void pitchBendBn_actionPerformed(ActionEvent e)
  { this.trombonePanel1.setPitchBendMode(true);
    this.pitchBendBn.setEnabled(false);
    this.noteChangeBn.setEnabled(true);

  }

  void noteChangeBn_actionPerformed(ActionEvent e)
  { this.trombonePanel1.setPitchBendMode(false);
    this.pitchBendBn.setEnabled(true);
    this.noteChangeBn.setEnabled(false);

  }
}