package edu.ucf.cs.dml.simnets.measureme.dbase;
import net.jini.core.entry.Entry;
import java.sql.*;
/**
 * A result set as queried from the database that is forwarded as a ResultHolder
 *  object
 */
public class QueryResults implements Entry
{ public String replyToID=null;  //an id specified by the original requestor
  public ResultHolder results=null;
  public String error=null;


  public QueryResults()
  {
  }

  public QueryResults(ResultSet results)
  { try{
     this.results=new ResultHolder(results);
     System.out.println(this.results.getColumnCount());
       }
    catch(Exception e)
    { e.printStackTrace();
    }
  }

  public QueryResults(String errorMessage)
  { this.error=errorMessage;
  }
  public ResultHolder getResults()
  { return results;
  }

  public void setResults(ResultSet results) throws java.sql.SQLException
  { this.results=new ResultHolder(results);
  }

  public void setResults(ResultHolder results)
  { this.results=results;
  }

  public String getReplyToID()
  {
    return replyToID;
  }

  public void setReplyToID(String newReplyToID)
  {
    replyToID = newReplyToID;
  }

  public void setError(String error)
  { this.error=error;
  }

  public String getError()
  { return this.error;
  }

  public String toString() {
    return "QueryResults for "+replyToID;
  }
}