CREATE TABLE exhibitor(
 id  smallint PRIMARY KEY, -- the actual scancode
 visitdate date, --the day that the exhibitor visited 
 age smallint, -- the age of the exhibitor
 weight smallint, -- the weight of the exhibitor
 gender varchar, -- male or female 
 guide smallint,      -- code used for which guide avatar selected
 

 countrycode smallint, -- the integer code of the country see the country
                       -- table 
 state varchar,   -- the 2 character state representation
 countycode smallint, -- the code for the county see the county table
 schoolgroup smallint, -- the code for the school 
  
 stationvalues smallint[100], --up to 100 2 byte integers station values
                              --station values are given multiplication
                              --Last station  score= (StationID -1)*4 +1 
                              --Station id = (index-1) / 4 +1
                             
 stationsvisited smallint --denotes the number of stations actually
                          --visited by this exhibitor 	
 
);
CREATE UNIQUE INDEX exhibitor_date_index ON exhibitor(id,visitdate);
