package edu.ucf.cs.dml.simnets.measureme.devices;

import edu.ucf.cs.dml.simnets.measureme.MeasureMeGlobal;
import java.util.StringTokenizer;

public abstract class GrayCodeDeviceSimulator extends NDADeviceSimulator {

  /**
   * This method undoes the actions of <code>gray_to_binary</code> in
   * <code>GrayCodeDevice</code>
   * @param binNumber number of ticks on gray code device
   * @return equivalent gray code number
   */
  public static int binary_to_gray(int binNumber) {
    return (binNumber >> 1) ^ binNumber;
  }

} // GrayCodeDeviceSimulator