package edu.ucf.cs.dml.simnets.measureme.devices;

/**
 * Title:        Devices for Measure Me<p>
 * Description:  Device Wrapppers/Code for measure me.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */

public class JumpDevice extends OSCDevice {

  public JumpDevice() {
    super();
    this.deviceStartLoginCodes=OSCDeviceCodes.JUMP_LOGIN;
    System.out.println("JumpDevice constructed");
  }

  public boolean syncDevice() {
    return true;
  }


  public void writeToDevice(String parm1) throws DeviceDataException {
    System.out.println("Device: writeToDevice: "+parm1);
    if(parm1.equals("Chase"))
      { this.chaseMode();

       }
    else
     super.writeToDevice(parm1);

  }

  public void chaseMode() {
    this.deviceStartLoginCodes=OSCDeviceCodes.JUMP_CHASE_SEQUENCE;
    try {
      super.start();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void start() throws DeviceFailureException {
    this.deviceStartLoginCodes=OSCDeviceCodes.JUMP_LOGIN;
    super.start();
  }
} // JumpDevice