package edu.ucf.cs.dml.simnets.measureme.devices;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import javax.swing.border.*;

public class LoadCellFrame extends JFrame implements ActionListener
{
  XYLayout xYLayout1 = new XYLayout();
  JProgressBar jProgressBar1 = new JProgressBar();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;

  //Construct the frame
  public LoadCellFrame()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception
  {
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    this.getContentPane().setLayout(xYLayout1);
    this.setResizable(false);
    this.setTitle("TestLoadCell");
    jProgressBar1.setBorder(BorderFactory.createLoweredBevelBorder());
    jProgressBar1.setToolTipText("This is a toolbar");
    xYLayout1.setHeight(70);
    xYLayout1.setWidth(399);
    this.getContentPane().add(jProgressBar1, new XYConstraints(3, 7, 386, 31));
    this.setSize(400,70);
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    //System.out.println(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }


  }

  public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
  //System.out.println(e);
    if (cmd.equals("Exit")) {
    System.out.println("Ok");
    System.exit(0);
    }

  }
}
