package edu.ucf.cs.dml.simnets.measureme.devices;

/**
 * All OSC devices have a login code. Upon receiving that code, they send an
 * ACK signal.  Subclasses of this class should satisfy these requirements.
 */
public abstract class OSCDeviceSimulator extends DeviceSimulator {
  protected int loginCodeByteCounter = 0;
  protected final static char[] ACK_SIGNAL = {2,0,0};

  public void write(String data) {
    // only applicable for Height (not an OSC device)
  }
}