package edu.ucf.cs.dml.simnets.measureme.devices;

import java.util.EventObject;

/**
 * Encapsulates data from the simulator GUI.
 */
public class SimulatorGUIEvent extends EventObject {
  protected Object data;

  /**
   * Constructs a new event.
   * @param source object firing this event
   * @param data information inside this event
   */
  public SimulatorGUIEvent(Object source, Object data) {
    super(source);
    this.data = data;
  }

  /**
   * Returns data in event.
   * @return data
   */
  public Object getData() {
    return data;
  }

} // SimulatorGUIEvent