package edu.ucf.cs.dml.simnets.measureme.devices;

/**
 * Title:        Devices for Measure Me
 * Description:  Device Wrapppers/Code for measure me.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class TestReactionDevice
{ ReactionTimeDeviceProxy rdp=null;
  ReactionTimeDevice device=null;

  public TestReactionDevice()
  { device=new ReactionTimeDevice();
    rdp=new ReactionTimeDeviceProxy(device);


  }


  public void doTest()
  { try{
   this.rdp.setMode("Chase");
         Thread.sleep(10000);


     System.out.println("Starting test:");
   System.out.println("Sending sound mode");
     this.rdp.setMode("Sound");
     Thread.sleep(3000);
 //     System.out.println("Sending touch mode");
 //     this.rdp.setMode("Touch");
 //    Thread.sleep(3000);
//     System.out.println("Sending sight mode");
 //    this.rdp.setMode("Sight");
  //   Thread.sleep(3000);
     System.out.println("Waiting for time value");
     rdp.waitForDeviceMeasure();
     System.out.println("Time was"+ rdp.measure());
     System.out.println("Sending chase mode");
     Thread.sleep(3000);
     this.rdp.setMode("Chase");
     Thread.sleep(3000);
     System.out.println("Done with test");

     }
    catch(Exception e)
    { e.printStackTrace();
    }
  }

  public static void main(String[] args)
  {
    TestReactionDevice tRD = new TestReactionDevice();
    tRD.doTest();
  }
}