package edu.ucf.cs.dml.simnets.measureme.server;

import net.jini.core.lease.Lease;

public class LeaseRenewalEvent extends java.util.EventObject {
    private Lease lease;
    private long expiration;
    private Exception ex;

    public LeaseRenewalEvent(LeaseManager source,
        Lease lease, long expiration, Exception ex)
    {
        super(source);
        this.lease = lease;
        this.ex = ex;
    }

    public Lease getLease() {
        return lease;
    }

    public long getExpiration() {
        return expiration;
    }

    public Exception getException() {
        return ex;
    }
}
