
/**
 * Title:        MeasureMe Server Side<p>
 * Description:  Server side code. <p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.server;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.*;

public class StationsAvailablePanel extends JPanel implements PropertyChangeListener
{
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JScrollPane jScrollPane1 = new JScrollPane();

  JLabel stationsStatusLabel = new JLabel();
  StationAvailableServer server=null;

  DefaultListModel aModel=new DefaultListModel();
  JList stationsAvailableList = new JList(aModel);

  public StationsAvailablePanel()
  {
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  public  StationsAvailablePanel(StationAvailableServer s)
  { this();
    this.server=s;
    s.addPropertyChangeListener(this);
  }

  void jbInit() throws Exception
  {
    jLabel1.setText("Stations Currently Available");
    this.setBorder(BorderFactory.createLineBorder(Color.black));
    this.setLayout(xYLayout1);
    xYLayout1.setWidth(300);
    xYLayout1.setHeight(196);
    jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jScrollPane1.setAutoscrolls(true);
    this.add(jScrollPane1, new XYConstraints(61, 47, 177, 62));
    stationsAvailableList.setPrototypeCellValue("Index 1234567890");
    jScrollPane1.getViewport().add(stationsAvailableList, null);
    jScrollPane1.getViewport().setView(this.stationsAvailableList);
    this.add(jLabel1, new XYConstraints(71, 16, 157, -1));
    this.add(stationsStatusLabel, new XYConstraints(59, 139, -1, -1));
  }

  public void propertyChange(PropertyChangeEvent evt)
  {
    if( evt.getPropertyName().equals("lastActiveStations"));
    { System.out.println("evt "+ evt);
      this.aModel.removeAllElements();;
      Enumeration enum=this.server.getLastActiveStations().elements();
      ExhibitAvailableInfo inf=null;
      while(enum.hasMoreElements())
      { inf=(ExhibitAvailableInfo)enum.nextElement();
        this.aModel.addElement(new String(new Integer( inf.getStationID()).toString()+ " " +inf.getStationName()  ));
      }
      //Vector v=this.server.getLastActiveStations();
      //Enumeration enum2
      //this.aModel.addAll();
      System.out.print(this.aModel.size());
      //this.stationsAvailableList.setModel(this.theData);
    }


  }
}