
/**
 * Title:        MeasureMe Server Side<p>
 * Description:  Server side code. <p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.server;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;

public class TestStationsAvailable extends JFrame
{
  XYLayout xYLayout1 = new XYLayout();
  StationsAvailablePanel stationsAvailablePanel1 = null;
  StationAvailableServer sas=null;
  public TestStationsAvailable()
  {
    try
    { sas=new StationAvailableServer();
      stationsAvailablePanel1=new StationsAvailablePanel(sas);
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public static void main(String[] args)
  {   try  {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
    }
    TestStationsAvailable testStationsAvailable = new TestStationsAvailable();

        testStationsAvailable.validate();
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = testStationsAvailable.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    testStationsAvailable.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    testStationsAvailable.setVisible(true);
    //testStationsAvailable.connectUp();
  }

  private void jbInit() throws Exception
  {
    this.getContentPane().setLayout(xYLayout1);
    this.getContentPane().add(stationsAvailablePanel1, new XYConstraints(46, 37, -1, -1));
  }
}