
/**
 * Title:        <p>
 * Description:  Creates a text file of all the countries in the data base
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author Dean Reed
 * @version 1.0
 */
package edu.ucf.cs.dml.mapthing;
import com.borland.jb.io.AsciiInputStream;
import com.borland.jb.io.AsciiOutputStream;
import java.util.*;
import java.io.*;
//import com.objectspace.jgl.BinaryPredicate;
//import com.objectspace.jgl.PriorityQueue;

public class CreateTextDB //implements WorldMapCallbackInterface, BinaryPredicate
{


/*TheWorldPanel wPanel=new TheWorldPanel(this);
  Hashtable countryNamesDB =new Hashtable(); //this is from a passed text file
  Hashtable countryNamesFromMap = new Hashtable();

  PriorityQueue stateNamesFromMap = new PriorityQueue(this);
  PriorityQueue countryQue=new PriorityQueue(this);
  PriorityQueue countyNamesFromMap = new PriorityQueue(this);
  int stateSize=0;
  int countySize=0;

  public CreateTextDB()
  { Vector countryNames=wPanel.getCountryNames();
    Vector countyNames=wPanel.getCountyNames();
    Vector stateNames=wPanel.getStatesNames();
    System.out.println("countries " +countryNames.size());
    System.out.println("counties " +countyNames.size());
    System.out.println("states " +stateNames.size());
    int i=1;
    Enumeration enum=countryNames.elements();
    countySize=countyNames.size();
    stateSize=stateNames.size();
    while(enum.hasMoreElements())
    { String s=(String)enum.nextElement();
      if(!countryNamesFromMap.containsKey(s))
      { countryNamesFromMap.put(s,new Integer(i));
        countryQue.push(s);
        i++;
      }
    }

    enum=countyNames.elements();
    while(enum.hasMoreElements())
    { countyNamesFromMap.push(enum.nextElement());

    }

    enum=stateNames.elements();
    while(enum.hasMoreElements())
    { stateNamesFromMap.push(enum.nextElement());

    }


  }

  public CreateTextDB(String textCountryFile)
  { this();
    readTextDB(textCountryFile);

  }

  protected void readTextDB(String textFileName)
  { File inFile=new File(textFileName);
    try{
      FileInputStream fis=new FileInputStream(inFile);
      AsciiInputStream ais=new AsciiInputStream(fis);
      String inString=null;
      int i=1;
      while((inString=ais.readLine())!=null)
      { countryNamesDB.put(inString,new Integer(i));
        i++;
      }
      fis.close();
     }
     catch(Exception e)
     { e.printStackTrace();
     }
      System.out.println("Done reading db");
  }

  protected void writeCountryDB()
  { FileOutputStream fos=null;
    try{
     fos=new FileOutputStream(new File("mapcountryDB.txt"));
     AsciiOutputStream aos =new AsciiOutputStream(fos);

     Enumeration enum=countryNamesFromMap.keys();
     String cName=null;
    while(enum.hasMoreElements())
     { cName=(String)enum.nextElement();
       aos.writeln(cName+" "+countryNamesFromMap.get(cName).toString());
     }

     int i=1;
     while(!countryQue.isEmpty())
     { aos.writeln((String)countryQue.pop()+"|"+ i);
       i++;
     }
     aos.flush();


    }
    catch(Exception e)
    { e.printStackTrace();
    }

    if(fos!=null)
     try{ fos.close();
        }
     catch(Exception e2)
     {e2.printStackTrace();
     }
      System.out.println("Done writing country db");
  }

  protected void writeStateDB()
  { FileOutputStream fos=null;
    try{
     fos=new FileOutputStream(new File("mapStateDB.txt"));
     AsciiOutputStream aos =new AsciiOutputStream(fos);
   //  Enumeration enum=stateNamesFromMap.keys();
     String cName=null;
     int i=1;
     while(!stateNamesFromMap.isEmpty())
     { cName=(String)stateNamesFromMap.pop();
       aos.writeln(cName+"|"+i);
       i++;
     }
     aos.flush();
    }
    catch(Exception e)
    { e.printStackTrace();
    }

    if(fos!=null)
     try{ fos.close();
        }
     catch(Exception e2)
     {e2.printStackTrace();
     }

     System.out.println("Done writing state db");
  }

  protected void writeCountyDB()
  { FileOutputStream fos=null;
    try{
     fos=new FileOutputStream(new File("mapCountyDB.txt"));

     AsciiOutputStream aos =new AsciiOutputStream(fos);


     String cName=null;
     int i=1;
     while(!countyNamesFromMap.isEmpty())
     { cName=(String)countyNamesFromMap.pop();
       aos.writeln(cName+"|"+i);
       //System.out.print();
       i++;
     }
     aos.flush();
    }
    catch(Exception e)
    { e.printStackTrace();
    }

    if(fos!=null)
     try{ fos.close();
        }
     catch(Exception e2)
     {e2.printStackTrace();
     }

     System.out.println("Done writing county db");
  }

   //do some comparison on map, and the input database
  protected void writeExtendedStat()
  { FileOutputStream fos=null;
    try{
     fos=new FileOutputStream(new File("mapDBInfo.txt"));
     AsciiOutputStream aos =new AsciiOutputStream(fos);
     aos.writeln("Number of countries in map: " + new Integer(countryNamesFromMap.size()));

     aos.writeln("Number of states in map: " + stateSize );
     aos.writeln("Number of Florida counties in map: " +  new Integer(countySize));
     aos.writeln();
     if(countryNamesDB.size()>0)
     { aos.writeln("        Countries found in the DB that are not in the Map");
       aos.writeln("---------------------------------------------------------------------");
       Enumeration enum=countryNamesDB.keys();
       while(enum.hasMoreElements())
       { String s=(String)enum.nextElement();
         if(!countryNamesFromMap.containsKey(s))
          aos.writeln(s);
       }
       aos.writeln();
       aos.writeln("        Countries found in the Map that are not in the DB");
       aos.writeln("---------------------------------------------------------------------");
       enum=countryNamesFromMap.keys();
       while(enum.hasMoreElements())
       { String s=(String)enum.nextElement();
         if(!countryNamesDB.containsKey(s))
          aos.writeln(s);
       }
     }
     aos.flush();
    }
    catch(Exception e)
    { e.printStackTrace();
    }
    if(fos!=null)
     try{ fos.close();
        }
     catch(Exception e2)
     {e2.printStackTrace();
     }
   System.out.println("Done writing comparison of db");
  }
  public void writeDBs()
  { writeCountryDB();
    writeStateDB();
    writeCountyDB();
    writeExtendedStat();
  }
  public static void main(String[] args)
  { CreateTextDB createTextDB1=null;
    if((args!=null)&&(args.length==0))
     createTextDB1 = new CreateTextDB();
    else
     createTextDB1 = new CreateTextDB(args[0]);
    createTextDB1.writeDBs();
    System.exit(0);
  }

  public void areaSelected(String area)
  {
    //TODO: Implement this edu.ucf.cs.dml.mapthing.WorldMapCallbackInterface method
  }

  public void finalAreaSelected(String area)
  {
    //TODO: Implement this edu.ucf.cs.dml.mapthing.WorldMapCallbackInterface method
  }

  public boolean execute(Object parm1, Object parm2)
  { String str1=(String)parm1;
    String str2=(String)parm2;

    return (str1.compareTo(str2)>0);
  }
*/
}