package edu.ucf.cs.dml.mapthing;

import java.util.EventObject;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c)
 * Company:
 * @author Mathew Lowery
 * @version 1.0
 */

/**
 * This class encapsulates two lower level events in GraphicHotSpot objects:
 * (1) clicking inside the component and (2) clicking on the popup that denotes
 * the label for the GraphicHotSpot.  Clicking inside the component generates a
 * mouseClicked event whereas clicking on the popup generates an actionPerformed
 * event.  This event is the only event fired from GraphicHotSpot.
 */
public class HotSpotClickedEvent extends EventObject
{
  public HotSpotClickedEvent(Object source) {
    super(source);
  }
}