
/**
 * Title:        Analysis Station<p>
 * Description:  Analysis Station Code<p>
 * Copyright:    Copyright (c) Dean Reed<p>
 * Company:      IST/DML<p>
 * @author Dean Reed
 * @version 1.0
 */
package edu.ucf.cs.dml.simnets.measureme.analysis;
import edu.ucf.cs.dml.simnets.measureme.dbase.*;
import java.util.Hashtable;
/**
 * Provides an interface for common services needed in the analysis station
 */
public interface AnalysisServiceInterface
{ /**
   *  PURPOSE: Performs queries to the database. In case of error client should
   *   check the results error methods.
   */

  public QueryResults performQuery(QueryReplyRequest query);

  /**
   * PURPOSE: return the county mappings
   */

  public Hashtable getCountyTable();

  /**
   * PURPOSE: return the country mappings
   */

  public Hashtable getCountryTable();


}