package edu.ucf.cs.dml.simnets.measureme.analysis;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.util.*;
import java.awt.event.*;
import com.borland.jbcl.control.*;
import java.text.*;
/**
 * Title: MeasureMe Analysis Station
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author Jennifer Farris
 * @version 2.0
 */

public class PopUpInstructions extends JPanel {

  JTextPane instr=new JTextPane();
  XYLayout xYLayout1=new XYLayout();
  JButton cmdOK=new JButton("OK");

  public PopUpInstructions() {
    xYLayout1.setWidth(200);
    xYLayout1.setHeight(260);
    this.setLayout(xYLayout1);
    this.setBackground(Color.white);
    this.setBorder(BorderFactory.createLineBorder(Color.black));
    this.add(instr,new XYConstraints(10,10,180,200));
    this.add(cmdOK,new XYConstraints(65,230,70,20));

    cmdOK.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        OK_pressed();
      }
    });

  }

  void setText(String iTxt)
  { SimpleAttributeSet centerAlign = new SimpleAttributeSet();
    StyleConstants.setAlignment(centerAlign,StyleConstants.ALIGN_CENTER);
    SimpleAttributeSet charStyle1 = new SimpleAttributeSet();
    StyleConstants.setFontFamily(charStyle1, "Times New Roman");
    StyleConstants.setFontSize(charStyle1, 16);
    Document contentModel=instr.getDocument();
    instr.setParagraphAttributes(centerAlign,true);
    instr.setEnabled(false);

    try{
      contentModel.remove(0,contentModel.getLength());
      contentModel.insertString(contentModel.getLength(),iTxt, charStyle1);
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  void OK_pressed()
  {
    this.setVisible(false);
  }

  void setDim(int w,int h)
  { xYLayout1.setWidth(w);
    xYLayout1.setWidth(h);
    this.add(instr,new XYConstraints(10,10,w-20,h-60));
    this.add(cmdOK,new XYConstraints((int)((w/2)-35),h-30,70,20));
  }
}