package edu.ucf.cs.dml.simnets.measureme.analysis;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.awt.event.*;
import com.borland.jbcl.control.*;
import edu.ucf.cs.dml.simnets.measureme.server.*;
//import java.applet.AudioClip;

/**
 * Title: MeasureMe Analysis Station
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author: Jennifer Farris
 * @version 2.0
 */

public class TycoonPanel extends JPanel implements CurveDrawingCompletedListener, AnimCompletedListener, SleepCompletedListener{
  XYLayout xYLayout1=new XYLayout();
  AddCurvePanel curvePanel1;
  JButton butn;
  int lastScore=0;
  int highestScore=0;
  int aniNum=1;
  int goNumber;
  Exhibitor exhibitor=null;
  //AudioClip tycSound;
  JButton fathBtn=new JButton();
  JButton NBABtn=new JButton();
  JButton promBtn=new JButton();
  JButton goBn2=new JButton();
  ImageIcon calcIcon=null;
  JLabel label1;
  JLabel times=new JLabel();
  JLabel rentalPrice=new JLabel("",JLabel.CENTER);
  AddCurvePanel curve1=new AddCurvePanel();
  Font labelFont=new java.awt.Font("SansSerif", 1, 16);
  Vector butns=new Vector();
  Vector labels=new Vector();
  JLabel times2=new JLabel();
  TransparentImage stick1=new TransparentImage();
  TransparentImage capstick2=new TransparentImage();
  TransparentImage caption3=new TransparentImage();
  TransparentImage capstick4=new TransparentImage();
  TransparentImage capstick5=new TransparentImage();
  TransparentImage capstick6=new TransparentImage();
  JLabel male=new JLabel("",JLabel.CENTER);
  JLabel femQuant=new JLabel("",JLabel.CENTER);
  JLabel unitStock=new JLabel("",JLabel.CENTER);
  JLabel unitRent=new JLabel("",JLabel.CENTER);
  JLabel maleQuant=new JLabel("",JLabel.CENTER);
  JLabel female=new JLabel();
  JLabel stockCost=new JLabel("",JLabel.CENTER);
  JButton galaBtn=new JButton();
  TransparentImage skate=new TransparentImage();
  JLabel totalStock=new JLabel();
  JLabel totalRent=new JLabel();
  JLabel plusLabel=new JLabel();
  JLabel equal1=new JLabel();
  JLabel equal2=new JLabel();
  JLabel equal3=new JLabel();
  JLabel equal4=new JLabel();
  JLabel rentDesc=new JLabel();
  JLabel costDesc=new JLabel();
  JLabel stockDesc=new JLabel("",JLabel.RIGHT);
  JLabel undLine1=new JLabel();
  JLabel undLine2=new JLabel();
  JLabel orderDesc=new JLabel("Order",JLabel.RIGHT);
  JLabel profitDesc=new JLabel();
  JLabel profit=new JLabel("",JLabel.CENTER);
  JLabel head1=new JLabel("",JLabel.CENTER);
  JLabel head2=new JLabel("",JLabel.CENTER);
  JLabel evntLbl=new JLabel("",JLabel.CENTER);
  String eName="";
  JTextArea instr=new JTextArea();
  JTextArea instr2=new JTextArea();
  ImageIcon goIcon=null;
  ImageIcon downBlIcon=null;
  ImageIcon downYlIcon=null;
  ImageIcon upBlIcon=null;
  ImageIcon upYlIcon=null;
  ImageIcon galaIcon=null;
  ImageIcon NBAIcon=null;
  ImageIcon promIcon=null;
  ImageIcon fathIcon=null;
  JButton goBn=new JButton();
  Vector graphData=new Vector();
  Integer[] curveVector=new Integer[20];
  JButton calcButton=new JButton();

  public TycoonPanel() {
    try
    { for(int i=0;i<40;i++)
      {   butn=new JButton();
          butns.addElement(butn);
      }
      for(int i=0;i<20;i++)
      {   label1=new JLabel("",JLabel.CENTER);
          labels.addElement(label1);
      }
      goBn.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        { goBn_actionPerformed();
        }
      });
      calcButton.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        { calcBn_actionPerformed();
        }
      });

      for(int i=0;i<20;i+=2)
      { ((JButton)butns.elementAt(i)).addActionListener(new java.awt.event.ActionListener()
        {
          public void actionPerformed(ActionEvent e)
          { upBn_actionPerformed(e);
          }
        });

        ((JButton)butns.elementAt(i+1)).addActionListener(new java.awt.event.ActionListener()
        {
          public void actionPerformed(ActionEvent e)
          { downBn_actionPerformed(e);
          }
        });
      }

      for(int i=20;i<40;i+=2)
      { ((JButton)butns.elementAt(i)).addActionListener(new java.awt.event.ActionListener()
        {
          public void actionPerformed(ActionEvent e)
          { upBn_actionPerformed(e);
          }
        });

        ((JButton)butns.elementAt(i+1)).addActionListener(new java.awt.event.ActionListener()
        {
          public void actionPerformed(ActionEvent e)
          { downBn_actionPerformed(e);
          }
        });
      }
      galaBtn.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        { eventBtn_actionPerformed(e);
        }
      });
      promBtn.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        { eventBtn_actionPerformed(e);
        }
      });
      NBABtn.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        { eventBtn_actionPerformed(e);
        }
      });
      fathBtn.addActionListener(new java.awt.event.ActionListener()
      {
        public void actionPerformed(ActionEvent e)
        { eventBtn_actionPerformed(e);
        }
      });
      jbInit();
    }
    catch(Exception e)
    { e.printStackTrace();
    }
  }

  protected void jbInit() throws Exception
  { this.curve1.addCurveDrawingCompletedListener(this);
    this.curve1.addAnimCompletedListener(this);
    this.curve1.addSleepCompletedListener(this);
    goNumber=0;
    goBn.setEnabled(false);
    goBn.setVisible(false);
    instr2.setVisible(false);
    evntLbl.setVisible(false);
    evntLbl.setForeground(Color.blue);
    evntLbl.setFont(this.labelFont);
    stick1.setImageName("c:\\analysisart\\Stick275x419.gif");
    capstick2.setImageName("c:\\analysisart\\CaptionStick275x319.gif");
    caption3.setImageName("c:\\analysisart\\Caption115x384.gif");
    capstick4.setImageName("c:\\analysisart\\CapStick275x319.gif");
    capstick5.setImageName("c:\\analysisart\\CapStick275x300.gif");
    capstick6.setImageName("c:\\analysisart\\CapStick275x252.gif");
    skate.setImageName("c:\\analysisart\\Skate180x130.gif");
    goIcon=new ImageIcon("C:\\analysisart\\go.gif");
    downBlIcon=new ImageIcon("C:\\analysisart\\downBlue.gif");
    upBlIcon=new ImageIcon("C:\\analysisart\\upBlue.gif");
    downYlIcon=new ImageIcon("C:\\analysisart\\downYellow.gif");
    upYlIcon=new ImageIcon("C:\\analysisart\\upYellow.gif");
    calcIcon=new ImageIcon("C:\\analysisart\\calculate.gif");
    galaIcon=new ImageIcon("C:\\analysisart\\museum140x50.gif");
    promIcon=new ImageIcon("C:\\analysisart\\prom140x50blue.gif");
    NBAIcon=new ImageIcon("C:\\analysisart\\NBA140x50.gif");
    fathIcon=new ImageIcon("C:\\analysisart\\father140x50blue.gif");
    this.calcButton.setIcon(calcIcon);
    calcButton.setBackground(Color.white);
    calcButton.setRequestFocusEnabled(false);
    calcButton.setBorderPainted(false);
    this.goBn.setIcon(goIcon);
    this.goBn.setDisabledIcon(goIcon);
    goBn.setBackground(Color.white);
    goBn.setRequestFocusEnabled(false);
    goBn.setBorderPainted(false);
    stick1.setVisible(true);
    capstick2.setVisible(false);
    capstick2.setDrawEdge(false);
    this.galaBtn.setIcon(galaIcon);
    galaBtn.setRequestFocusEnabled(false);
    galaBtn.setBorderPainted(false);
    galaBtn.setToolTipText("Have a museum gala at your skating rink");
    this.promBtn.setIcon(promIcon);
    capstick6.setVisible(false);
    capstick6.setDrawEdge(false);
    promBtn.setRequestFocusEnabled(false);
    promBtn.setBorderPainted(false);
    promBtn.setToolTipText("Have a prom party at your skating rink");
    curve1.jbInit();
    this.fathBtn.setIcon(fathIcon);
    fathBtn.setRequestFocusEnabled(false);
    fathBtn.setBorderPainted(false);
    fathBtn.setToolTipText("Have father & daughter night at your skating rink");
    this.NBABtn.setIcon(NBAIcon);
    NBABtn.setRequestFocusEnabled(false);
    NBABtn.setBorderPainted(false);
    NBABtn.setToolTipText("Have an NBA reunion at your skating rink");
    this.goBn2.setIcon(goIcon);
    goBn2.setBackground(Color.white);
    goBn2.setRequestFocusEnabled(false);
    goBn2.setBorderPainted(false);
    goBn2.setEnabled(false);
    goBn2.setVisible(false);
    capstick4.setVisible(false);
    capstick4.setDrawEdge(false);
    int x;
    instr.setLineWrap(true);
    instr.disable();
    instr.setDisabledTextColor(Color.white);
    instr.setBackground(new Color(51,102,255));
    instr2.setLineWrap(true);
    instr2.disable();
    instr2.setDisabledTextColor(Color.white);
    instr2.setBackground(new Color(51,102,255));
    xYLayout1.setWidth(800);
    xYLayout1.setHeight(600);
    this.setBackground(Color.white);
    this.setLayout(xYLayout1);
    x=65;
    for(int i=0;i<20;i+=2)
    { ((JButton)butns.elementAt(i)).setIcon(upBlIcon);
      ((JButton)butns.elementAt(i)).setBackground(Color.white);
      ((JButton)butns.elementAt(i)).setRequestFocusEnabled(false);
      ((JButton)butns.elementAt(i)).setBorderPainted(false);
      ((JButton)butns.elementAt(i)).setDisabledIcon(upBlIcon);
      ((JButton)butns.elementAt(i)).setEnabled(false);

      this.add(((JButton)butns.elementAt(i)),new XYConstraints(x,36,30,18));
      ((JButton)butns.elementAt(i+1)).setIcon(downBlIcon);
      ((JButton)butns.elementAt(i+1)).setBackground(Color.white);
      ((JButton)butns.elementAt(i+1)).setRequestFocusEnabled(false);
      ((JButton)butns.elementAt(i+1)).setBorderPainted(false);
      ((JButton)butns.elementAt(i+1)).setDisabledIcon(downBlIcon);
      ((JButton)butns.elementAt(i+1)).setEnabled(false);
      this.add(((JButton)butns.elementAt(i+1)),new XYConstraints(x,72,30,18));
      x=x+45;
    }

    x=65;
    for(int i=20;i<40;i+=2)
    {
      ((JButton)butns.elementAt(i)).setEnabled(false);
      ((JButton)butns.elementAt(i)).setIcon(upYlIcon);
      ((JButton)butns.elementAt(i)).setBackground(Color.white);
      ((JButton)butns.elementAt(i)).setRequestFocusEnabled(false);
      ((JButton)butns.elementAt(i)).setBorderPainted(false);
      ((JButton)butns.elementAt(i)).setDisabledIcon(upYlIcon);
      this.add(((JButton)butns.elementAt(i)),new XYConstraints(x,95,30,18));
      ((JButton)butns.elementAt(i+1)).setEnabled(false);
      ((JButton)butns.elementAt(i+1)).setIcon(downYlIcon);
      ((JButton)butns.elementAt(i+1)).setBackground(Color.white);
      ((JButton)butns.elementAt(i+1)).setRequestFocusEnabled(false);
      ((JButton)butns.elementAt(i+1)).setBorderPainted(false);
      ((JButton)butns.elementAt(i+1)).setDisabledIcon(downYlIcon);
      this.add(((JButton)butns.elementAt(i+1)),new XYConstraints(x,131,30,18));
      x=x+45;
    }

    x=65;
    for(int i=0;i<10;i++)
    {
      ((JLabel)labels.elementAt(i)).setFont(this.labelFont);
      ((JLabel)labels.elementAt(i)).setBorder(BorderFactory.createLineBorder(new Color(33,0,144)));
      ((JLabel)labels.elementAt(i)).setText("0");
      ((JLabel)labels.elementAt(i)).setForeground(Color.blue);
      ((JLabel)labels.elementAt(i)).setToolTipText("Number of skates ordered: male size " + Integer.toString(i+3));
      graphData.addElement(new Integer(0));
      this.add(((JLabel)labels.elementAt(i)),new XYConstraints(x,54,30,18));
      x=x+45;
    }

    x=65;
    for(int i=10;i<20;i++)
    {
      ((JLabel)labels.elementAt(i)).setFont(this.labelFont);
      ((JLabel)labels.elementAt(i)).setBorder(BorderFactory.createLineBorder(new Color(33,0,144)));
      ((JLabel)labels.elementAt(i)).setText("0");
      ((JLabel)labels.elementAt(i)).setForeground(Color.blue);
      ((JLabel)labels.elementAt(i)).setToolTipText("Number of skates ordered: female size " + Integer.toString(i-7));
      graphData.addElement(new Integer(0));
      this.add(((JLabel)labels.elementAt(i)),new XYConstraints(x,113,30,18));
      x=x+45;
    }

    /*
    java.io.File q = new java.io.File("c:\\analysismusic\\FinalCash.wav");

    try {
      tycSound = java.applet.Applet.newAudioClip(q.toURL());
      } catch (java.net.MalformedURLException e) {
      tycSound = null;
    }
    */
    male.setForeground(Color.black);
    male.setFont(this.labelFont);
    male.setText("Male:");
    female.setForeground(Color.black);
    female.setFont(this.labelFont);
    female.setText("Female:");
    calcButton.setToolTipText("Press calculate when you are done placing your order");
    goBn.setToolTipText("Press next to continue");
    goBn2.setToolTipText("Press next to continue");
    caption3.setVisible(false);
    caption3.setDrawEdge(false);
    galaBtn.setEnabled(false);
    galaBtn.setVisible(false);
    promBtn.setEnabled(false);
    promBtn.setVisible(false);
    fathBtn.setEnabled(false);
    fathBtn.setVisible(false);
    NBABtn.setEnabled(false);
    NBABtn.setVisible(false);
    femQuant.setToolTipText("Total female skates ordered");
    femQuant.setBorder(BorderFactory.createLineBorder(new java.awt.Color(33,0,144)));
    femQuant.setFont(new java.awt.Font("SansSerif", 1, 18));
    femQuant.setText("0");
    femQuant.setBackground(Color.yellow);
    femQuant.setForeground(Color.blue);
    femQuant.setOpaque(true);
    maleQuant.setToolTipText("Total male skates ordered");
    maleQuant.setBorder(BorderFactory.createLineBorder(new java.awt.Color(33,0,144)));
    maleQuant.setBackground(Color.blue);
    maleQuant.setForeground(Color.green);
    maleQuant.setOpaque(true);
    maleQuant.setFont(new java.awt.Font("SansSerif", 1, 18));
    maleQuant.setText("0");
    stockCost.setBorder(BorderFactory.createLineBorder(new Color(33,0,144)));
    stockCost.setFont(new java.awt.Font("SansSerif", 1, 20));
    stockCost.setForeground(Color.blue);
    capstick5.setVisible(false);
    capstick5.setDrawEdge(false);
    stockCost.setText("0");
    stockCost.setToolTipText("Total skates ordered");
    rentalPrice.setBorder(BorderFactory.createLineBorder(new Color(33,0,144)));
    rentalPrice.setFont(new java.awt.Font("SansSerif", 1, 20));
    rentalPrice.setText("150");
    rentalPrice.setVisible(false);
    rentalPrice.setForeground(Color.blue);
    rentalPrice.setToolTipText("Total Skates Rented");
    orderDesc.setFont(new java.awt.Font("SansSerif", 1, 12));
    orderDesc.setForeground(Color.black);
    stockDesc.setFont(new java.awt.Font("SansSerif", 1, 12));
    stockDesc.setForeground(Color.black);
    stockDesc.setText("Rented");
    stockDesc.setVisible(false);
    times.setFont(new java.awt.Font("Sans Serif",1,18));
    times.setText("*");
    times.setForeground(Color.black);
    times.setVisible(false);
    times2.setFont(new java.awt.Font("Sans Serif",1,18));
    times2.setText("*");
    times2.setForeground(Color.black);
    times2.setVisible(false);
    unitRent.setBorder(BorderFactory.createLineBorder(new Color(33,0,144)));
    unitRent.setFont(new java.awt.Font("Sans Serif",1,20));
    unitRent.setText(" $2");
    unitRent.setToolTipText("Cost to rent one pair of skates");
    unitRent.setVisible(false);
    unitRent.setForeground(Color.blue);
    unitStock.setBorder(BorderFactory.createLineBorder(new Color(33,0,144)));
    unitStock.setFont(new java.awt.Font("Sans Serif",1,20));
    unitStock.setText("-$1");
    unitStock.setVisible(false);
    unitStock.setForeground(Color.red);
    unitStock.setToolTipText("Cost to stock one pair of skates");
    totalRent.setBorder(BorderFactory.createLineBorder(new Color(33,0,144)));
    totalRent.setFont(new java.awt.Font("Sans Serif",1,20));
    totalRent.setText("$1800");
    totalRent.setVisible(false);
    totalRent.setBackground(Color.green);
    totalRent.setForeground(Color.blue);
    totalRent.setOpaque(true);
    totalRent.setToolTipText("Total money you made on skate rental");
    totalStock.setFont(new java.awt.Font("Sans Serif",1,20));
    totalStock.setBorder(BorderFactory.createLineBorder(new Color(33,0,144)));
    totalStock.setBackground(Color.green);
    totalStock.setForeground(Color.red);
    totalStock.setOpaque(true);
    totalStock.setToolTipText("Your cost to stock the skates");
    totalStock.setText("-$300");
    totalStock.setVisible(false);
    profit.setBorder(BorderFactory.createLineBorder(Color.black));
    profit.setFont(new java.awt.Font("Sans Serif",1,20));
    profit.setText("$300");
    profit.setVisible(false);
    profit.setBackground(Color.green);
    profit.setForeground(Color.blue);
    profit.setOpaque(true);
    profit.setToolTipText("The money you had left over after paying to stock the skates");
    equal1.setFont(this.labelFont);
    equal1.setText("=");
    equal1.setForeground(Color.black);
    equal2.setFont(this.labelFont);
    equal2.setText("=");
    equal2.setForeground(Color.black);
    equal3.setFont(this.labelFont);
    equal3.setText("=");
    equal3.setForeground(Color.black);
    equal3.setVisible(false);
    equal4.setFont(this.labelFont);
    equal4.setText("=");
    equal4.setForeground(Color.black);
    equal4.setVisible(false);
    stick1.setDrawEdge(false);
    costDesc.setFont(new java.awt.Font("SansSerif", 1, 12));
    costDesc.setText("Cost");
    costDesc.setForeground(Color.black);
    costDesc.setVisible(false);
    rentDesc.setFont(new java.awt.Font("SansSerif", 1, 12));
    rentDesc.setText("Revenue");
    rentDesc.setForeground(Color.black);
    rentDesc.setVisible(false);
    profitDesc.setFont(new java.awt.Font("SansSerif", 1, 12));
    profitDesc.setText("Profit");
    profitDesc.setForeground(Color.black);
    profitDesc.setVisible(false);
    undLine1.setFont(new java.awt.Font("SansSerif", 1, 12));
    undLine1.setText("_____________");
    undLine1.setForeground(Color.black);
    skate.setDrawEdge(false);
    undLine2.setFont(new java.awt.Font("SansSerif", 1, 12));
    undLine2.setText("_________");
    undLine2.setForeground(Color.black);
    undLine2.setVisible(false);
    plusLabel.setFont(new java.awt.Font("SansSerif", 1, 18));
    plusLabel.setText("+");
    plusLabel.setForeground(Color.black);
    head1.setFont(new java.awt.Font("SansSerif", 1, 12));
    head1.setText("Skates");
    head1.setForeground(Color.black);
    head2.setFont(new java.awt.Font("SansSerif", 1, 12));
    head2.setText("Quantity");
    head2.setForeground(Color.black);
    instr.setWrapStyleWord(true);
    instr.setFont(new java.awt.Font("SansSerif", 1, 20));
    instr.setForeground(Color.white);
    instr2.setWrapStyleWord(true);
    instr2.setFont(new java.awt.Font("SansSerif", 1, 15));
    instr2.setForeground(Color.white);
    instr.setVisible(false);
    calcButton.setVisible(false);
    calcButton.setEnabled(false);
    this.add(instr,new XYConstraints(555,205,215,175));
    this.add(curve1,new XYConstraints(10,149,-1,-1));
    this.add(male,new XYConstraints(20,54,45,16));
    this.add(female,new XYConstraints(0,113,65,16));
    this.add(galaBtn,new XYConstraints(650,200,140,50));
    this.add(promBtn,new XYConstraints(650,270,140,50));
    this.add(fathBtn,new XYConstraints(650,340,140,50));
    this.add(NBABtn,new XYConstraints(650,410,140,50));
    this.add(femQuant,new XYConstraints(570,111,50,22));
    this.add(maleQuant,new XYConstraints(570,52,50,22));
    this.add(stockCost,new XYConstraints(570,155,50,26));
    this.add(orderDesc,new XYConstraints(530,155,40,26));
    this.add(stockDesc,new XYConstraints(530,187,40,26));
    this.add(rentalPrice,new XYConstraints(570,187,50,26));
    this.add(times,new XYConstraints(625,157,10,26));
    this.add(times2,new XYConstraints(625,188,10,26));
    this.add(unitStock,new XYConstraints(635,155,40,26));
    this.add(unitRent,new XYConstraints(635,187,40,26));
    this.add(totalStock,new XYConstraints(690,155,55,26));
    this.add(totalRent,new XYConstraints(690,187,55,26));
    this.add(equal1,new XYConstraints(523,54,10,18));
    this.add(equal2,new XYConstraints(523,113,10,18));
    this.add(equal3, new XYConstraints(680,155,10,26));
    this.add(equal4,new XYConstraints(680,187,10,26));
    this.add(costDesc,new XYConstraints(746,155,50,26));
    this.add(rentDesc,new XYConstraints(746,187,50,26));
    this.add(undLine1,new XYConstraints(545,131,95,18));
    this.add(undLine2,new XYConstraints(687,205,75,18));
    this.add(plusLabel,new XYConstraints(545,113,20,18));
    this.add(profitDesc,new XYConstraints(746,228,50,26));
    this.add(profit,new XYConstraints(690,228,55,26));
    this.add(head1,new XYConstraints(570,18,50,12));
    this.add(head2,new XYConstraints(570,33,50,14));
    this.add(goBn,new XYConstraints(720,510,-1,-1));
    this.add(evntLbl, new XYConstraints(200,0,200,36));
    this.add(goBn2,new XYConstraints(635,510,-1,-1));
    this.add(calcButton,new XYConstraints(580,500,150,50));
    this.add(stick1,new XYConstraints(522,166,-1,-1));
    this.add(capstick2,new XYConstraints(525,180,-1,-1));
    this.add(caption3,new XYConstraints(525,195,-1,-1));
    this.add(skate, new XYConstraints(620,0,-1,-1));
    this.add(capstick4,new XYConstraints(525,180,-1,-1));
  }

  void upBn_actionPerformed(ActionEvent e)
  { int n;
    Integer r;
    int i;
    for(i=0;i<butns.size();i+=2)
    { if(e.getSource()==butns.elementAt(i))
      { n=Integer.parseInt( ((JLabel)labels.get(i/2)).getText() );
        if(n==44)
          ((JButton)butns.elementAt(i)).setEnabled(false);
        else
          ((JButton)butns.elementAt(i)).setEnabled(true);
        //enable down button
        ((JButton)butns.elementAt(i+1)).setEnabled(true);

        r=new Integer(n+1);
        ((JLabel)labels.elementAt(i/2)).setText(r.toString());
        graphData.setElementAt(r,i/2);
        curve1.paintRows(graphData);
      }
    }

    n=0;
    for(i=0;i<10;i++)
    { n=n+Integer.parseInt(((JLabel)labels.elementAt(i)).getText());
    }

    maleQuant.setText(Integer.toString(n));
    n=0;
    for(i=10;i<20;i++)
    { n=n+Integer.parseInt(((JLabel)labels.elementAt(i)).getText());
    }

    femQuant.setText(Integer.toString(n));
    n=Integer.parseInt(maleQuant.getText()) + Integer.parseInt(femQuant.getText());
    stockCost.setText(Integer.toString(n));
    if(n!=0)
      totalStock.setText("-$" +Integer.toString(n) );
    else
      totalStock.setText("$0");
  }

  void downBn_actionPerformed(ActionEvent e)
  { int n;
    int p=1;
    Integer r;
    int i;
    for(i=1;i<butns.size();i+=2)
    { if(e.getSource()==butns.elementAt(i))
      { n=Integer.parseInt( ((JLabel)labels.get(i-p)).getText() );
        if(n==1)
          ((JButton)butns.elementAt(i)).setEnabled(false);
        else
          ((JButton)butns.elementAt(i)).setEnabled(true);
        ((JButton)butns.elementAt(i-1)).setEnabled(true);
        r=new Integer(n-1);
        ((JLabel)labels.elementAt(i-p)).setText(r.toString());
        graphData.setElementAt(r,i-p);
        curve1.paintRows(graphData);
      }
      p++;
    }
    n=0;
    for(i=0;i<10;i++)
    { n=n+Integer.parseInt(((JLabel)labels.elementAt(i)).getText());
    }
    maleQuant.setText(Integer.toString(n));
    n=0;
    for(i=10;i<20;i++)
    { n=n+Integer.parseInt(((JLabel)labels.elementAt(i)).getText());
    }

    femQuant.setText(Integer.toString(n));
    n=Integer.parseInt(maleQuant.getText()) + Integer.parseInt(femQuant.getText());
    stockCost.setText(Integer.toString(n));
    if(n!=0)
      totalStock.setText("-$" +Integer.toString(n) );
    else
      totalStock.setText("$0");
  }

  void eventBtn_actionPerformed(ActionEvent e)
  { curve1.stick3.setVisible(false);
    caption3.setVisible(false);
    capstick4.setVisible(true);
    evntLbl.setVisible(true);

    this.add(instr,new XYConstraints(555,205,215,175));
    this.add(capstick4,new XYConstraints(525,180,-1,-1));
    instr.setText("This graph is an even distribution. To adjust your order, press the up and down arrows. Your cost to stock the skates is $1 per pair.");
    for(int i=0;i<butns.size();i++)
      ((JButton)butns.elementAt(i)).setEnabled(true);
    galaBtn.setVisible(false);
    promBtn.setVisible(false);
    fathBtn.setVisible(false);
    NBABtn.setVisible(false);

    if(e.getSource()==galaBtn)
    { eName="gala";
      evntLbl.setText("Museum Gala");
      curveVector[0]=new Integer(0);
      curveVector[1]=new Integer(0);
      curveVector[2]=new Integer(5);
      curveVector[3]=new Integer(14);
      curveVector[4]=new Integer(24);
      curveVector[5]=new Integer(34);
      curveVector[6]=new Integer(41);
      curveVector[7]=new Integer(43);
      curveVector[8]=new Integer(38);
      curveVector[9]=new Integer(29);
      curveVector[10]=new Integer(11);
      curveVector[11]=new Integer(20);
      curveVector[12]=new Integer(31);
      curveVector[13]=new Integer(40);
      curveVector[14]=new Integer(44);
      curveVector[15]=new Integer(43);
      curveVector[16]=new Integer(36);
      curveVector[17]=new Integer(25);
      curveVector[18]=new Integer(14);
      curveVector[19]=new Integer(4);
    }
    else if(e.getSource()==promBtn)
    { eName="prom";
      evntLbl.setText("High School Prom");
      curveVector[0]=new Integer(0);
      curveVector[1]=new Integer(0);
      curveVector[2]=new Integer(2);
      curveVector[3]=new Integer(5);
      curveVector[4]=new Integer(9);
      curveVector[5]=new Integer(15);
      curveVector[6]=new Integer(25);
      curveVector[7]=new Integer(37);
      curveVector[8]=new Integer(40);
      curveVector[9]=new Integer(25);
      curveVector[10]=new Integer(4);
      curveVector[11]=new Integer(7);
      curveVector[12]=new Integer(11);
      curveVector[13]=new Integer(18);
      curveVector[14]=new Integer(32);
      curveVector[15]=new Integer(42);
      curveVector[16]=new Integer(32);
      curveVector[17]=new Integer(14);
      curveVector[18]=new Integer(3);
      curveVector[19]=new Integer(0);
    }
    else if(e.getSource()==NBABtn)
    { eName="NBA";
      evntLbl.setText("NBA Reunion");
      curveVector[0]=new Integer(0);
      curveVector[1]=new Integer(0);
      curveVector[2]=new Integer(0);
      curveVector[3]=new Integer(0);
      curveVector[4]=new Integer(0);
      curveVector[5]=new Integer(0);
      curveVector[6]=new Integer(0);
      curveVector[7]=new Integer(3);
      curveVector[8]=new Integer(11);
      curveVector[9]=new Integer(25);
      curveVector[10]=new Integer(0);
      curveVector[11]=new Integer(0);
      curveVector[12]=new Integer(0);
      curveVector[13]=new Integer(0);
      curveVector[14]=new Integer(0);
      curveVector[15]=new Integer(0);
      curveVector[16]=new Integer(0);
      curveVector[17]=new Integer(0);
      curveVector[18]=new Integer(0);
      curveVector[19]=new Integer(0);
    }
    else
    { eName="father";
      evntLbl.setText("Father & Daughter Night");
      curveVector[0]=new Integer(0);
      curveVector[1]=new Integer(0);
      curveVector[2]=new Integer(0);
      curveVector[3]=new Integer(0);
      curveVector[4]=new Integer(0);
      curveVector[5]=new Integer(1);
      curveVector[6]=new Integer(4);
      curveVector[7]=new Integer(10);
      curveVector[8]=new Integer(20);
      curveVector[9]=new Integer(30);
      curveVector[10]=new Integer(28);
      curveVector[11]=new Integer(17);
      curveVector[12]=new Integer(10);
      curveVector[13]=new Integer(3);
      curveVector[14]=new Integer(0);
      curveVector[15]=new Integer(0);
      curveVector[16]=new Integer(0);
      curveVector[17]=new Integer(0);
      curveVector[18]=new Integer(0);
      curveVector[19]=new Integer(0);
    }
    goBn.setEnabled(true);
    goBn.setVisible(true);
    unitStock.setVisible(true);
    totalStock.setVisible(true);
    costDesc.setVisible(true);
    times.setVisible(true);
    equal3.setVisible(true);
    for(int i=0;i<butns.size();i++)
      ((JButton)butns.elementAt(i)).setEnabled(true);
  }

  void goBn_actionPerformed()
  { Integer r;
    //tycSound.play();
    if(goNumber==0)
    { this.add(goBn,new XYConstraints(635,510,-1,-1));
      instr.setVisible(true);
      curve1.instr.setVisible(false);
      curve1.caption1.setVisible(false);
      stick1.setVisible(false);
      capstick2.setVisible(true);
      curve1.paintRows(graphData);
      instr.setText(new String("The graph will show you the distribution of both female and male skate sizes that you have ordered." + '\n' + "Press next to continue"));
    }
    else if(goNumber==1)
    { curve1.paintRows(graphData);
      goBn.setEnabled(false);
      goBn.setVisible(false);
      capstick2.setVisible(false);
      caption3.setVisible(true);
      curve1.stick3.setVisible(true);
      instr.setFont(new java.awt.Font("SansSerif",1,18));
      this.add(instr,new XYConstraints(545,215,80,320));
      this.add(caption3,new XYConstraints(525,181,-1,-1));
      instr.setText("Choose an event to plan!" + "\n" + "Press one of the four event buttons to start stocking skates for that event." );
      galaBtn.setVisible(true);
      galaBtn.setEnabled(true);
      promBtn.setVisible(true);
      promBtn.setEnabled(true);
      fathBtn.setVisible(true);
      fathBtn.setEnabled(true);
      NBABtn.setEnabled(true);
      NBABtn.setVisible(true);
    }
    else if(goNumber==2)
    { curve1.paintRows(graphData);
      goBn.setEnabled(false);
      goBn.setVisible(false);
      System.out.println(eName);
      curve1.setDataSet(curveVector,eName);
    }

    goNumber++;

  }

  void calcBn_actionPerformed()
  { Integer r;
    Integer p;
    int m;
    int labValue=0;
    curve1.bCalc=true;
    curve1.clearAllIcons();
    System.out.println("Calculate pressed");
    promBtn.setEnabled(false);
    promBtn.setVisible(false);
    galaBtn.setEnabled(false);
    galaBtn.setVisible(false);
    fathBtn.setEnabled(false);
    fathBtn.setVisible(false);
    NBABtn.setEnabled(false);
    NBABtn.setVisible(false);
    for(int i=0;i<labels.size();i++)
    { m=Integer.parseInt(((JLabel)labels.elementAt(i)).getText());
      r=new Integer(m);
      if(r.compareTo(curveVector[i])>0)
        m=curveVector[i].intValue();
      else
        m=r.intValue();
      labValue=labValue+m;
    }

    rentalPrice.setText(Integer.toString(labValue));
    int pht=labValue*2;
    if(pht==0)
      totalRent.setForeground(Color.red);
    else
      totalRent.setForeground(Color.blue);
    totalRent.setText(" $" + Integer.toString(pht));
    m=(Integer.parseInt(rentalPrice.getText())*2)-Integer.parseInt(stockCost.getText());

    if(m<0)
    { profit.setForeground(Color.red);
      profit.setText("-$" + Integer.toString(Math.abs(m)));
    }
    else if(m==0)
    { profit.setForeground(Color.red);
      profit.setText(" $" + Integer.toString(m));
    }
    else
    { profit.setForeground(Color.blue);
      profit.setText(" $" + Integer.toString(m));
    }
    times2.setVisible(true);
    rentalPrice.setVisible(true);
    equal4.setVisible(true);
    totalRent.setVisible(true);
    stockDesc.setVisible(true);
    rentDesc.setVisible(true);
    capstick5.setVisible(false);
    capstick6.setVisible(true);
    instr.setFont(new Font("Sans Serif",1,15));
    instr2.setVisible(true);
    instr2.setText("The dollar bills represent the skates you ordered. The rented skates");
    instr.setText("fall on and under the bell curve. The red dollars are the skates you ordered that were not rented. The white rectangles are all the skates that you could have ordered to increase your profit.");
    this.add(instr,new XYConstraints(550,358,220,125));
    this.add(instr2,new XYConstraints(630,274,140,80));
    this.add(capstick6,new XYConstraints(525,254,-1,-1));
    profit.setVisible(true);
    profitDesc.setVisible(true);
    undLine2.setVisible(true);
    unitRent.setVisible(true);
    calcButton.setVisible(false);
    calcButton.setEnabled(false);
    goBn2.setEnabled(true);
    goBn2.setVisible(true);
    for(int i=0;i<butns.size();i++)
      ((JButton)butns.elementAt(i)).setEnabled(false);

    if(profit.getText().substring(0,2).equals("-$"))
    {
        lastScore=0-(Integer.parseInt(profit.getText().substring(2)));
    }
    else
    {
        lastScore=Integer.parseInt(profit.getText().substring(2));

    }
    if(highestScore < lastScore)
      highestScore=lastScore;

  }
  public void resetAll()
  {
    graphData.removeAllElements();
    this.curve1.myRunThread=null;
    while(curve1.myRunThread!=null)
    {
    }
    curve1.bAnim=false;
    this.curve1.removeCurveDrawingCompletedListener(this);
    this.curve1.removeAnimCompletedListener(this);
    this.curve1.removeSleepCompletedListener(this);
    aniNum=1;
    // if(tycSound!=null)
    // tycSound.stop();
    try
    { jbInit();
    }
    catch(Exception e)
    { e.printStackTrace();
    }

    curve1.bClear=true;
    curve1.bCurve=false;
    curve1.bCalc=false;
    curve1.clearAllIcons();
  }

  public void addAnimCompletedListener(AnimCompletedListener l)
  { this.curve1.addAnimCompletedListener(l);
  }
   public void addSleepCompletedListener(SleepCompletedListener l)
  { this.curve1.addSleepCompletedListener(l);
  }

  public void animDone(AnimCompletedEvent e)
  { if(curve1.bAnim==false)
    { for(int i=0;i<labels.size();i++)
        ((JLabel)labels.elementAt(i)).setText("0");
      maleQuant.setText("0");
      femQuant.setText("0");
    }
    else
    {
      aniNum++;
      if(aniNum!=16)
      { for(int i=0;i<labels.size();i++)
          ((JLabel)labels.elementAt(i)).setText(new Integer(aniNum).toString());
        maleQuant.setText(Integer.toString(10*aniNum));
        femQuant.setText(Integer.toString(10*aniNum));
        stockCost.setText(Integer.toString(20*aniNum));
      }
      else
      { curve1.myRunThread=null;
        while(curve1.myRunThread!=null)
        {
        }
        if(graphData.size()==0)
        { for(int i=0;i<20;i++)
            graphData.addElement(new Integer(15));
        }
        else
        { for(int i=0;i<20;i++)
            graphData.setElementAt(new Integer(15),i);
        }
        goBn.setEnabled(true);
        goBn.setVisible(true);
      }
    }
  }

  public void addCurveDrawingCompletedListener(CurveDrawingCompletedListener l)
  { this.curve1.addCurveDrawingCompletedListener(l);
  }

  public void curveDone(CurveDrawingCompletedEvent e)
  { instr.setFont(new java.awt.Font("SansSerif",1,17));
    instr.setText("This sample will help you decide how many skates to order for your event.  Adjust your order to maximize your profit. Press the calculate button to check your profit.");
    capstick4.setVisible(false);
    capstick5.setVisible(true);
    this.add(instr,new XYConstraints(555,205,155,240));
    this.add(capstick5,new XYConstraints(525,180,-1,-1));
    calcButton.setEnabled(true);
    calcButton.setVisible(true);
    for(int i=0;i<butns.size();i++)
      ((JButton)butns.elementAt(i)).setEnabled(true);
  }

  void startAnim()
  { curve1.bClear=false;
    curve1.bAnim=true;
    curve1.start();
  }

  public void sleepDone(SleepCompletedEvent e)
  { for(int i=0;i<labels.size();i++)
      ((JLabel)labels.elementAt(i)).setText("1");
    maleQuant.setText("10");
    femQuant.setText("10");
    stockCost.setText("20");
  }

  public void setClientExhibitor(Exhibitor exhibitor)
  {  this.exhibitor=exhibitor;
     highestScore=exhibitor.getTycScore();
     System.out.println("Exhibitor's highest score on Tycoon activity was " + highestScore);
  }

  public void setScore()
  { exhibitor.setTycScore(highestScore);

  }
}