package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.*;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class CalculatorInputPanel extends JPanel
{
  XYLayout xYLayout1 = new XYLayout();
  JLabel digitLabel = new JLabel();
  JButton numButton1 = new JButton();
  JButton numButton2 = new JButton();
  JButton numButton3 = new JButton();
  JButton numButton4 = new JButton();
  JButton numButton5 = new JButton();
  JButton numButton6 = new JButton();
  JButton numButton7 = new JButton();
  JButton numButton8 = new JButton();
  JButton numButton9 = new JButton();
  JButton numButton0 = new JButton();
  JButton jButton1 = new JButton();
  JButton clrButton = new JButton();
  private int maxFieldWidth=6;
  private transient Vector calculatorInputFinishedListeners;
  JButton jButton2 = new JButton();
  TitledBorder titledBorder1;

  public CalculatorInputPanel()
  {
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }
  void jbInit() throws Exception
  {
    titledBorder1 = new TitledBorder("");
    digitLabel.setBackground(Color.black);
    digitLabel.setFont(new java.awt.Font("SansSerif", 1, 16));
    digitLabel.setForeground(SystemColor.activeCaptionText);
    digitLabel.setOpaque(true);
    this.setLayout(xYLayout1);
    numButton1.setFont(new java.awt.Font("Dialog", 1, 14));
    numButton1.setText("1");
    numButton1.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        numButton1_actionPerformed(e);
      }
    });
    numButton2.setText("2");
    numButton2.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        numButton2_actionPerformed(e);
      }
    });
    numButton2.setFont(new java.awt.Font("Dialog", 1, 14));
    numButton3.setText("3");
    numButton3.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        numButton3_actionPerformed(e);
      }
    });
    numButton3.setFont(new java.awt.Font("Dialog", 1, 14));
    numButton4.setText("4");
    numButton4.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        numButton4_actionPerformed(e);
      }
    });
    numButton4.setFont(new java.awt.Font("Dialog", 1, 14));
    numButton5.setText("5");
    numButton5.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        numButton5_actionPerformed(e);
      }
    });
    numButton5.setFont(new java.awt.Font("Dialog", 1, 14));
    numButton6.setText("6");
    numButton6.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        numButton6_actionPerformed(e);
      }
    });
    numButton6.setFont(new java.awt.Font("Dialog", 1, 14));
    numButton7.setText("7");
    numButton7.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        numButton7_actionPerformed(e);
      }
    });
    numButton7.setFont(new java.awt.Font("Dialog", 1, 14));
    numButton8.setText("8");
    numButton8.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        numButton8_actionPerformed(e);
      }
    });
    numButton8.setFont(new java.awt.Font("Dialog", 1, 14));
    numButton9.setText("9");
    numButton9.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        numButton9_actionPerformed(e);
      }
    });
    numButton9.setFont(new java.awt.Font("Dialog", 1, 14));
    numButton0.setText("0");
    numButton0.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        numButton0_actionPerformed(e);
      }
    });
    numButton0.setFont(new java.awt.Font("Dialog", 1, 14));
    jButton1.setBackground(Color.green);
    jButton1.setFont(new java.awt.Font("SansSerif", 1, 14));
    jButton1.setText("ok");
    jButton1.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButton1_actionPerformed(e);
      }
    });
    clrButton.setText("clr");
    clrButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        clrButton_actionPerformed(e);
      }
    });
    clrButton.setBackground(Color.red);
    clrButton.setFont(new java.awt.Font("Dialog", 1, 14));
    xYLayout1.setWidth(183);
    xYLayout1.setHeight(257);
    jButton2.setFont(new java.awt.Font("Dialog", 1, 14));
    jButton2.setActionCommand("negBn");
    jButton2.setText("negative");
    jButton2.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButton2_actionPerformed(e);
      }
    });
    this.setBorder(BorderFactory.createEtchedBorder());
    this.add(digitLabel, new XYConstraints(13, 31, 156, 24));
    this.add(numButton5, new XYConstraints(63, 107, 53, -1));
    this.add(numButton2, new XYConstraints(63, 138, 53, -1));
    this.add(numButton3, new XYConstraints(116, 138, 53, -1));
    this.add(numButton6, new XYConstraints(116, 107, 53, -1));
    this.add(numButton7, new XYConstraints(9, 75, 53, -1));
    this.add(numButton4, new XYConstraints(9, 107, 53, -1));
    this.add(numButton1, new XYConstraints(9, 138, 53, -1));
    this.add(numButton0, new XYConstraints(63, 170, 53, -1));
    this.add(clrButton, new XYConstraints(9, 170, -1, -1));
    this.add(jButton1, new XYConstraints(116, 170, 53, -1));
    this.add(numButton8, new XYConstraints(63, 75, 53, -1));
    this.add(numButton9, new XYConstraints(116, 75, 53, -1));
    this.add(jButton2, new XYConstraints(9, 203, 161, -1));
  }
  public void setMaxFieldWidth(int newMaxFieldWidth)
  {
    maxFieldWidth = newMaxFieldWidth;
  }
  public int getMaxFieldWidth()
  {
    return maxFieldWidth;
  }

  protected void addDigit(String digit)
  { if(this.digitLabel.getText().length()<this.maxFieldWidth)
    { this.digitLabel.setText(this.digitLabel.getText()+digit);

    }
  }

  void numButton7_actionPerformed(ActionEvent e)
  { this.addDigit("7");
  }

  void numButton8_actionPerformed(ActionEvent e)
  { this.addDigit("8");

  }

  void numButton9_actionPerformed(ActionEvent e)
  { this.addDigit("9");

  }

  void numButton4_actionPerformed(ActionEvent e)
  { this.addDigit("4");

  }

  void numButton5_actionPerformed(ActionEvent e)
  { this.addDigit("5");

  }

  void numButton6_actionPerformed(ActionEvent e)
  { this.addDigit("6");

  }

  void numButton1_actionPerformed(ActionEvent e)
  { this.addDigit("1");

  }

  void numButton2_actionPerformed(ActionEvent e)
  { this.addDigit("2");

  }

  void numButton3_actionPerformed(ActionEvent e)
  { this.addDigit("3");

  }

  void numButton0_actionPerformed(ActionEvent e)
  {this.addDigit("0");

  }

  void clrButton_actionPerformed(ActionEvent e)
  { this.digitLabel.setText("");

  }
  public synchronized void removeCalculatorInputFinishedListener(CalculatorInputFinishedListener l)
  {
    if (calculatorInputFinishedListeners != null && calculatorInputFinishedListeners.contains(l))
    {
      Vector v = (Vector) calculatorInputFinishedListeners.clone();
      v.removeElement(l);
      calculatorInputFinishedListeners = v;
    }
  }
  public synchronized void addCalculatorInputFinishedListener(CalculatorInputFinishedListener l)
  {
    Vector v = calculatorInputFinishedListeners == null ? new Vector(2) : (Vector) calculatorInputFinishedListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      calculatorInputFinishedListeners = v;
    }
  }
  protected void fireDataChanged(CalculatorInputFinishedEvent e)
  {
    if (calculatorInputFinishedListeners != null)
    {
      Vector listeners = calculatorInputFinishedListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((CalculatorInputFinishedListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

  void jButton1_actionPerformed(ActionEvent e)
  { this.fireDataChanged(new CalculatorInputFinishedEvent(this));

  }

  public int getCalculatorInput()
  { if(this.digitLabel.getText().length()<2)
    { if(this.digitLabel.getText().equals("-"))
       return 0;
      if(this.digitLabel.getText().equals(""))
       return 0;
    }

    return Integer.parseInt(this.digitLabel.getText());

  }

  void jButton2_actionPerformed(ActionEvent e)
  { if(this.digitLabel.getText().length()>0)
    { if(this.digitLabel.getText().charAt(0)=='-')
       this.digitLabel.setText(this.digitLabel.getText().substring(1,this.digitLabel.getText().length()));
      else
       this.digitLabel.setText("-"+this.digitLabel.getText());
    }
    else
     this.digitLabel.setText("-");

  }








}