
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

public class DeviceErrorFrame extends JDialog
{
  JPanel panel1 = new JPanel();
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JButton jButton1 = new JButton();

  public DeviceErrorFrame(Frame frame, String title, boolean modal)
  {
    super(frame, title, modal);
    try
    {
      jbInit();
      pack();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  public DeviceErrorFrame()
  {
    this(null, "", false);
  }

  void jbInit() throws Exception
  {
    panel1.setLayout(xYLayout1);
    jLabel1.setToolTipText("");
    jLabel1.setText("Error: Device failed to initialize");
    jLabel2.setText("Please fix the device, and restart.");
    jButton1.setText("OK");
    jButton1.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jButton1_actionPerformed(e);
      }
    });
    this.setModal(true);
    this.setTitle("System Error");
    getContentPane().add(panel1);
    panel1.add(jLabel1, new XYConstraints(69, 23, 211, 28));
    panel1.add(jLabel2, new XYConstraints(69, 53, 184, -1));
    panel1.add(jButton1, new XYConstraints(175, 221, -1, -1));
  }

  void jButton1_actionPerformed(ActionEvent e)
  { this.setVisible(false);

  }
}