
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;

public class DigitalTimePanel extends JPanel implements Runnable
{
  XYLayout xYLayout1 = new XYLayout();
  JLabel minutesLabel = new JLabel();
  JLabel colonLabel = new JLabel();
  JLabel secondsLabel = new JLabel();
  protected short seconds=0;
  protected short minutes=0;
  protected boolean running=false;

  public DigitalTimePanel()
  {
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception
  {
    minutesLabel.setFont(new java.awt.Font("SansSerif", 1, 30));
    minutesLabel.setForeground(Color.blue);
    minutesLabel.setText("00");
    this.setBorder(BorderFactory.createRaisedBevelBorder());
    xYLayout1.setWidth(180);
    xYLayout1.setHeight(57);
    this.setLayout(xYLayout1);
    colonLabel.setText(":");
    colonLabel.setFont(new java.awt.Font("SansSerif", 1, 28));
    secondsLabel.setFont(new java.awt.Font("SansSerif", 1, 30));
    secondsLabel.setForeground(Color.red);
    secondsLabel.setText("00");
    this.add(minutesLabel, new XYConstraints(40, 8, 34, -1));
    this.add(colonLabel, new XYConstraints(82, 8, 12, -1));
    this.add(secondsLabel, new XYConstraints(102, 8, -1, -1));
  }

  public void run()
  { while(running)
    { increment();
      try{
        Thread.sleep(1000);
        }
      catch(Exception e)
      { e.printStackTrace();
      }
     }

  }

  protected void increment()
  { this.seconds++;
    if(this.seconds==60)
    { this.seconds=0;
      this.minutes++;
      if(this.minutes <10)
       this.minutesLabel.setText("0"+Integer.toString(this.minutes));
      else
       this.minutesLabel.setText(Integer.toString(this.minutes));
    }
    if(this.seconds<10)
     this.secondsLabel.setText("0"+ Integer.toString(this.seconds));
    else
     this.secondsLabel.setText(Integer.toString(this.seconds));

  }

  public void startRunning()
  { this.running=true;
    this.minutes=0;
    this.seconds=0;
    Thread t=new Thread(this);
    t.start();
  }

  public void stopRunning()
  { this.running=false;
    try{
     Thread.sleep(1000);
     }
     catch(Exception e)
     {}
    this.minutesLabel.setText("00");
    this.secondsLabel.setText("00");
  }
}