
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 *             storage object for hang time device inputs
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

public class HangTimeValue
{ long startTime;
  long endTime;
  float weight;

  public HangTimeValue(long startTime, long endTime, float weight)
  { this.startTime=startTime;
    this.endTime=endTime;
    this.weight=weight;

  }

  public long getDelta()
  { return endTime-startTime;
  }

  public float getWeight()
  { return weight;
  }

  public String toString()
  { return "HangTimeValue| delta:"  +this.getDelta()+" weight: "+this.weight;

  }

}