
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

public class HangTimeValueMap extends ValueMap
{ protected int uppertime=359; //seconds expected for max time

  public HangTimeValueMap()
  {
  }

  public Short getInternalValue(Object parm1)
  { HangTimeValue htv=(HangTimeValue)parm1;
    System.out.println("delta: "+htv.getDelta() + " divuded by time "+ (this.uppertime*1000));
    System.out.println((((double) htv.getDelta()/1000)/((double)this.uppertime) * 255));
    if((htv.getDelta()/(this.uppertime*1000))>=1)
     return new Short((short)255);
    else
     return new Short( (short)  (((double) htv.getDelta()/1000)/((double)this.uppertime) * 255));
  }

  public Object getActualValue(Short parm1)
  { return new Float(((float)parm1.shortValue())/((float)255) * this.uppertime);



  }

  public String getMetricUnits()
  { return "s";

  }
}