//package analysis;
package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class HeightValueMap extends ValueMap
{

  public HeightValueMap()
  { super();
    this.metricUnits="in"; //meters
  }
  public String getMetricUnits()
  { return metricUnits;

  }
  public Object getActualValue(Short deviceValue)
  { System.out.println("Actual value for: " + deviceValue + " is " +new Float(deviceValue.shortValue() * 0.234375+36f).toString() );
    return new Float(deviceValue.shortValue() * 0.234375+36f);
    /**@todo: implement this edu.ucf.cs.dml.simnets.measureme.client.ValueMap abstract method*/
  }
  public Short getInternalValue(Object actualValue)
  { System.out.println("Actual inches value passed to heightvaluemap: "+actualValue);
    Float act=(Float)actualValue;
    Short returnShort=null;
    if(act.floatValue()<36f)
     returnShort= new Short((short)0);
    else
     if(act.floatValue()>96f)
      returnShort= new Short((short)255);
     else
      returnShort=new Short((short)  Math.round((act.floatValue()-36f)*4.266666-1 ));
    System.out.println("Height internal value is:"+ returnShort);
    return returnShort;
  }
}