package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class JumpValueMap extends ValueMap {

  public JumpValueMap() {
    super();
  }

  public String getMetricUnits() {
    return "in";
  }

  /**
   * This function takes the value returned from getInternalValue and
   * converts it to a physical measurement.  Each sensor is 0.5 in.
   * apart.
   */
  public Object getActualValue(Short deviceValue) {
    return new Float(((deviceValue.shortValue())*.5));
  }

  public Short getInternalValue(Object actualValue) {
    return new Short((short)(((Short) actualValue).shortValue()));
  }
}