

/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.net.*;
import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.*;

public class NewAgePanel extends JPanel
{
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JLabel lastNumLabel = new JLabel();
  JLabel firstNumLabel = new JLabel();
  JButton upBn1 = new JButton();
  JButton dnBn1 = new JButton();
  JButton upBn2 = new JButton();
  JButton dnBn2 = new JButton();
  ImageIcon upBnIcon=null;
  ImageIcon dnBnIcon=null;
  ImageIcon upBnRolloverIcon=null;
  ImageIcon dnBnRolloverIcon=null;
  ImageIcon doneIcon=null;
  JButton doneBn = new JButton();
  private transient Vector ageSelectedListeners;
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  TitledBorder titledBorder1;

  GuiParameters gp;
  public NewAgePanel(GuiParameters gp)
  {
    this.gp = gp;
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception
  { upBnRolloverIcon=new ImageIcon(new java.net.URL((URL)gp.getParameter("baseURL"),"buttons/up_rollover.gif"));
     dnBnRolloverIcon=new ImageIcon(new java.net.URL((URL)gp.getParameter("baseURL"),"buttons/down_rollover.gif"));
     upBnIcon=new ImageIcon(new java.net.URL((URL)gp.getParameter("baseURL"),"buttons/up.gif"));
     dnBnIcon=new ImageIcon(new java.net.URL((URL)gp.getParameter("baseURL"),"buttons/down.gif"));
     doneIcon=new ImageIcon(new java.net.URL((URL)gp.getParameter("baseURL"),"buttons/whendone.gif"));
      titledBorder1 = new TitledBorder("");
    jLabel1.setFont(new java.awt.Font("SansSerif", 1, 26));
    jLabel1.setText("Please use the arrows to select your age:");
    this.setLayout(xYLayout1);
    firstNumLabel.setFont(new java.awt.Font("SansSerif", 0, 50));
    firstNumLabel.setBorder(BorderFactory.createLoweredBevelBorder());
    firstNumLabel.setRequestFocusEnabled(false);
    firstNumLabel.setToolTipText("");
    firstNumLabel.setText("0");
    upBn1.setRequestFocusEnabled(false);
    upBn1.setActionCommand("upBn1");
    upBn1.setIcon(upBnIcon);
    upBn1.setPressedIcon(upBnRolloverIcon);
    upBn1.setRolloverIcon(upBnIcon);
    upBn1.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        upBn1_actionPerformed(e);
      }
    });
    lastNumLabel.setFont(new java.awt.Font("SansSerif", 0, 50));
    lastNumLabel.setBorder(BorderFactory.createLoweredBevelBorder());
    lastNumLabel.setRequestFocusEnabled(false);
    lastNumLabel.setDisplayedMnemonic('0');
    lastNumLabel.setText("1");
    upBn2.setRequestFocusEnabled(false);
    upBn2.setIcon(upBnIcon);
    upBn2.setPressedIcon(upBnRolloverIcon);
    upBn2.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        upBn2_actionPerformed(e);
      }
    });
    dnBn1.setRequestFocusEnabled(false);
    dnBn1.setIcon(dnBnIcon);
    dnBn1.setPressedIcon(dnBnRolloverIcon);
    dnBn1.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        dnBn1_actionPerformed(e);
      }
    });
    dnBn2.setRequestFocusEnabled(false);
    dnBn2.setIcon(dnBnIcon);
    dnBn2.setPressedIcon(dnBnRolloverIcon);
    dnBn2.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        dnBn2_actionPerformed(e);
      }
    });
    doneBn.setFont(new java.awt.Font("Serif", 0, 15));
    doneBn.setBorder(BorderFactory.createRaisedBevelBorder());
    doneBn.setRequestFocusEnabled(false);
    doneBn.setFocusPainted(false);
    doneBn.setIcon(doneIcon);
    doneBn.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        doneBn_actionPerformed(e);
      }
    });
    jLabel2.setFont(new java.awt.Font("SansSerif", 1, 50));
    jLabel2.setText("I am");
    jLabel3.setText("years old.");
    jLabel3.setFont(new java.awt.Font("SansSerif", 1, 50));
    this.setRequestFocusEnabled(false);
    xYLayout1.setWidth(800);
    xYLayout1.setHeight(600);
    this.add(firstNumLabel, new XYConstraints(244, 190, -1, -1));
    this.add(jLabel1, new XYConstraints(146, 32, -1, -1));
    this.add(doneBn, new XYConstraints(265, 424, 270, 48));
    this.add(lastNumLabel, new XYConstraints(301, 190, -1, -1));
    this.add(upBn2, new XYConstraints(301, 114, 62, -1));
    this.add(dnBn1, new XYConstraints(209, 268, 62, -1));
    this.add(dnBn2, new XYConstraints(301, 268, 62, -1));
    this.add(upBn1, new XYConstraints(209, 114, 62, -1));
    this.add(jLabel3, new XYConstraints(368, 187, -1, -1));
    this.add(jLabel2, new XYConstraints(121, 187, -1, -1));
  }

  void upBn1_actionPerformed(ActionEvent e)
  {  if(this.getFistInt() <9)
      this.firstNumLabel.setText(new Integer(this.getFistInt()+1).toString());

  }

  protected int getFistInt()
  { return Integer.valueOf(this.firstNumLabel.getText()).intValue();
  }

  protected int getLastInt()
  { return Integer.valueOf(this.lastNumLabel.getText()).intValue();
  }

  void upBn2_actionPerformed(ActionEvent e)
  {  if(this.getLastInt() <9)
      this.lastNumLabel.setText(new Integer(this.getLastInt()+1).toString());

  }

  void dnBn1_actionPerformed(ActionEvent e)
  { if(this.getFistInt() >0)
      this.firstNumLabel.setText(new Integer(this.getFistInt()-1).toString());
    if(this.getFistInt() ==0)
     if(this.getLastInt() <=0)
      this.lastNumLabel.setText("1");
  }

  void dnBn2_actionPerformed(ActionEvent e)
  {  if(this.getLastInt() >0)
        this.lastNumLabel.setText(new Integer(this.getLastInt()-1).toString());
     if(this.getFistInt()==0)
      if(this.getLastInt()==0)
       this.lastNumLabel.setText("1");
  }

  public int getLastAge()
  { return  this.getFistInt()*10 + this.getLastInt();
  }

  public synchronized void removeAgeSelectedListener(AgeSelectedListener l)
  {
    if (ageSelectedListeners != null && ageSelectedListeners.contains(l))
    {
      Vector v = (Vector) ageSelectedListeners.clone();
      v.removeElement(l);
      ageSelectedListeners = v;
    }
  }

  public synchronized void addAgeSelectedListener(AgeSelectedListener l)
  {
    Vector v = ageSelectedListeners == null ? new Vector(2) : (Vector) ageSelectedListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      ageSelectedListeners = v;
    }
  }

  protected void fireAgeSelected(AgeSelectedEvent e)
  {
    if (ageSelectedListeners != null)
    {
      Vector listeners = ageSelectedListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((AgeSelectedListener) listeners.elementAt(i)).ageSelected(e);
      }
    }
  }

  void doneBn_actionPerformed(ActionEvent e)
  { this.fireAgeSelected(new AgeSelectedEvent(new Short((short)this.getLastAge())));
    this.firstNumLabel.setText("0");
    this.lastNumLabel.setText("1");
  }


}