
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class PickColorDialog extends JDialog
{
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JColorChooser jColorChooser1 = new JColorChooser();
  JButton pickBn = new JButton();

  public PickColorDialog(Frame frame, String title, boolean modal)
  {
    super(frame, title, modal);
    try
    {
      jbInit();
      pack();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  public PickColorDialog()
  {
    this(null, "", false);
  }

  void jbInit() throws Exception
  {
    panel1.setLayout(borderLayout1);
    this.setResizable(false);
    this.setTitle("Choose Color");
    this.setModal(true);
    pickBn.setForeground(Color.magenta);
    pickBn.setText("Press this button when you have picked your favorite color!");
    pickBn.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        pickBn_actionPerformed(e);
      }
    });
    getContentPane().add(panel1);
    panel1.add(jColorChooser1, BorderLayout.NORTH);
    panel1.add(pickBn, BorderLayout.SOUTH);
  }

  void pickBn_actionPerformed(ActionEvent e)
  { //this.setEnabled(false);
    this.setVisible(false);
  }

  public java.awt.Color getColor()
  { return jColorChooser1.getColor();
  }
}