//package analysis;
package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */
import java.util.Hashtable;
public  class StationInfo
{ protected static String[] stationNames={"Balance","Eye Span","Flexibility","Grip",
                                "Hand Span","Finger Length","Fingertip to Elbow",
                                "Foot Length","Arm Span","Hang Time","Height",
                                "Jump","Musical Scale","Pheripheral Vision","Reaction Time"};

  Hashtable stationIDs =new Hashtable();
  public StationInfo()
  { for(int i=0;i<this.stationNames.length;i++)
     this.stationIDs.put(stationNames[i],new Integer(i));
  }

  public static String[] getStationNames()
  { return stationNames;

  }

  public int getID(String stationName)
  { Integer retInt=(Integer)this.stationIDs.get(stationName);
    if(retInt!=null)
     return retInt.intValue();
    else
     return -1;

  }


}