package edu.ucf.cs.dml.simnets.measureme.dbase;

import net.jini.space.JavaSpace;
import com.sun.jini.outrigger.JavaSpaceAdmin;
import com.sun.jini.outrigger.AdminIterator;
import edu.ucf.cs.dml.simnets.measureme.server.*;
import java.rmi.RemoteException;
import net.jini.core.transaction.*;
import net.jini.core.entry.*;
import net.jini.admin.Administrable;


/**
 * Title:        MeasureMe Database project
 * Description:
 * Copyright:    Copyright (c) Dean Reed
 * Company:      IST-DML
 * @author Mathew Lowery
 * @version 1.0
 */

/**
 * Tool for displaying the contents of a JavaSpace.
 */
public class JavaSpaceBrowser {

  public JavaSpaceBrowser() throws Exception {
    JavaSpaceAdmin javaSpaceAdmin = (JavaSpaceAdmin) ((Administrable) MMSpaceAccessor.getSpace()).getAdmin();

    // create template for class
    Entry entry = new ExhibitorWrapper();

    // what transaction does tuple belong
    Transaction trans = null;

    AdminIterator iterator = javaSpaceAdmin.contents(entry, trans);

    Entry next = null;
    while ((next = iterator.next()) != null) {
      System.out.println(next.toString());
    }
  }

  public static void main(String[] args) throws Exception {
    new JavaSpaceBrowser();
  }

} // JavaSpaceBrowser