package edu.ucf.cs.dml.simnets.measureme.devices;
import java.beans.*;
import java.util.*;
import javax.swing.UIManager;
import java.awt.*;
import java.awt.event.*;

public class GrayCodeTest
{
  private GrayCodeDevice grayCodeDevice;
  private GrayCodeDeviceProxy gcdp=null;
  private String readData;
  boolean packFrame = false;
  Vector v = new Vector();
  private int i;
  LoadCellFrame frame = new LoadCellFrame();

  //Construct the application
  public GrayCodeTest() throws DeviceFailureException
  {
    grayCodeDevice = new FootLengthDevice();
    //grayCodeDevice.initialize();
    //grayCodeDevice.addDevicePropertyChangeListener(this);

    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame)
      frame.pack();
    else
      frame.validate();
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
      frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
      frame.setVisible(true);
    frame.jProgressBar1.setValue(0);
  }

  public void doTest(){
  v.removeAllElements();


 // try {
 // System.out.println("Starting Device");
//  grayCodeDevice.start();
//  }catch (DeviceFailureException badStart){
//  }
   this.gcdp=new FootLengthDeviceProxy(this.grayCodeDevice);


   try{
    //this.grayCodeDevice.start();
    while(true)
    { //this.gcdp.setDeviceInterface();

      gcdp.waitForDeviceMeasure();
      Short s=(Short)gcdp.measure();
      if(s.shortValue()!=233)
       frame.jProgressBar1.setValue((int)Math.round(s.shortValue()/2.55));
     }
   }
   catch(Exception e)
   { e.printStackTrace();
   }
  }

  //Main method
  public static void main(String[] args)
  {

   GrayCodeTest vLoadCellTest = null;
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
    }
   // new LoadCellTest();
   try{



   vLoadCellTest = new GrayCodeTest();
   System.out.println("Doing Test");



   vLoadCellTest.doTest();
   }catch (Exception e){
    e.printStackTrace();}
   }



}