package edu.ucf.cs.dml.simnets.measureme.devices;

/**
 * <code>DeviceSimulator</code>s should implement this interface so that
 * they can listen for GUI events and update the data they are sending
 * to the <code>Device</code>.
 */
public interface SimulatorGUIListener {

  /**
   * Called when data is available from the GUI.
   * @param e the data
   */
  public void guiEvent(SimulatorGUIEvent e);
}