package edu.ucf.cs.dml.simnets.measureme.server;

import java.rmi.RemoteException;
import net.jini.core.lease.*;

public interface LeaseManager {
    public void renewUntil(Lease lease, long stopTime,
        LeaseListener listener);

    public void renewFor(Lease lease, long duration,
        LeaseListener listener);

    public void cancel(Lease lease)
        throws UnknownLeaseException, RemoteException;
}
